
library(asreml);   library(asremlPlus)
library(rptR)


        # Pedigree      

        data.ped<-read.table('C:/Dropbox/Linkoping/_Data/Pedigree RJFowl 2013-17.csv', header=T, sep=',', dec='.', na.strings='NA')  ;  data.ped<-data.ped[1:882,]
        
        RJFped  <-data.frame  (data.ped$ID, data.ped$F.ID, data.ped$M.ID )
        names(RJFped)<-c('ID','F.ID', 'M.ID')
        RJFped$ID  <-as.factor(RJFped$ID); RJFped$M.ID<-as.factor(RJFped$M.ID); RJFped$F.ID<-as.factor(RJFped$F.ID)
        
        ainv <-  asreml.Ainverse(RJFped)$ginv
        



data.CJB  <-read.table('C:/Dropbox/Linkoping/_Data/CJB chicks 2014-2017.csv', header=T, sep=',', dec='.')  #   
head(data.CJB) ;    View (data.CJB)   

# add sex :
data.sex <- read.table('C:/Dropbox/Linkoping/_Data/sex 2012-17.csv', header=T, sep=',')  ; data.sex <- unique(data.sex)  
data.sex
data.MID <- RJFped [, c(1,3)]           #   

nrow(data.CJB)
data.CJB <- merge (data.CJB , data.sex, by='ID', all.y=FALSE, all.x=TRUE)  
nrow(data.CJB)
View(data.CJB)




#||||||||||||||||||||||||||||||||||||||||||||||||| ####
# => APPROACH (Y/N   => Probability of Approach)**** #########################
#||||||||||||||||||||||||||||||||||||||||||||||||| ####
 

#::::::::::::::::::::::::::::::::::::::::####
# I. ALL (5) cues  ####  
#::::::::::::::::::::::::::::::::::::::::####



ID <- as.factor(data.CJB$ID )
F <-   as.numeric(data.CJB$sex=="F")
year <-data.CJB$year
rewarded.white <- as.numeric(as.character (data.CJB$rewarded.white))
run.order <- data.CJB $run.order
order.cat <- data.CJB $order; first<- as.numeric (order.cat ==1);        #  second <- as.numeric (order.cat ==2);    third <- as.numeric (order.cat == 3)   

cue.type <- data.CJB$cue.type  ; NP <- as.numeric (cue.type =='NP') ;  M<- as.numeric (cue.type =='M')   ;  NN <- as.numeric (cue.type =='NN') ;    N<- as.numeric (cue.type =='N' | cue.type =='N ') 
cue.type[cue.type=="N "]<-"N"  ;   cue.type <- as.factor(as.character (cue.type))
prev.rewarded <-data.CJB $Prev.rewarded


Latency <-data.CJB$Latency       # note: max=30sec for all
Approached <- data.CJB$Approached
  flew.out  <-data.CJ$flew.out

F_C <-  (F -mean(F, na.rm=TRUE))                    # note some individuals with missing SEX ****
rewarded.white_C <- (rewarded.white -mean(rewarded.white))
prev.rewarded_C<- (prev.rewarded-mean(prev.rewarded))
run.order_C  <- (run.order-mean(run.order)) / (2*sd(run.order)) 
first_C  <- ( first-mean(first)) 
NP_C  <- (NP -mean(NP));     M_C <- ( M -mean( M, na.rm=T));     NN_C  <- (NN -mean(NN));      N_C<- (N -mean(N))

prev.rewarded.factor<- as.factor(prev.rewarded)
cuetype.factor<-as.factor(paste( NP, M, NN, N))

#______________________________________

hist(Latency)

round(tapply(Approached  ,  year, mean),2)
round( tapply(Approached  ,  cue.type, mean) ,2) # P=95%, NP=94%, M=84%,   NN=58%, N=46%

#_______________________________________________

# MODELS:

library(asreml)



data.5cues_univar   <- data.frame( ID,Approached , cue.type,   rewarded.white_C , prev.rewarded_C,  run.order_C ,first_C ,   NP_C, M_C, NN_C, N_C , cuetype.factor, prev.rewarded.factor, F_C ) 
      data.5cues_univar   <- data.5cues_univar[order(data.5cues_univar$ID, data.5cues_univar$run.order_C ), ]

 
table (prev.rewarded, cue.type )  # NB:   only 37 +ve out 2670 were preceded by another P  =>  huge SE in models with interaction prev.rew*cue.type 
        
   
 # a) including sex (244 out of 7144 cases missing sex):
      

        #  first  *cue.type   + prev rewarded  
            
            model.CJB.5cues.asreml.univ_full.a <- asreml(fixed=Approached ~  1 +F_C
                                                         + NP_C  + M_C  + NN_C  + N_C
                                                         + first_C + prev.rewarded_C
                                                         + NP_C:first_C  + M_C:first_C  + NN_C:first_C  + N_C:first_C 
                                                         #+NP_C:prev.rewarded_C  +M_C:prev.rewarded_C +NN_C:prev.rewarded_C +N_C:prev.rewarded_C 
                                                           ,random= ~ ID:idv(cuetype.factor), data= data.5cues_univar,  rcov= ~ units, maxiter = 200,  family=asreml.binomial(link='logit') , na.method.X= "include" ) 
           
             model.CJB.5cues.asreml.univ_full.b <-asreml(fixed=Approached ~  1 +F_C
                                                         + NP_C  + M_C  + NN_C  + N_C
                                                         + first_C + prev.rewarded_C
                                                         + NP_C:first_C  + M_C:first_C  + NN_C:first_C  + N_C:first_C 
                                                         #+NP_C:prev.rewarded_C  +M_C:prev.rewarded_C +NN_C:prev.rewarded_C +N_C:prev.rewarded_C 
                                                           ,random= ~ ID:idh(cuetype.factor), data= data.5cues_univar,  rcov= ~ units, maxiter = 200,  family=asreml.binomial(link='logit')  , na.method.X= "include" ) 
          
               model.CJB.5cues.asreml.univ_full.c <-asreml(fixed=Approached ~  1 +F_C 
                                                           + NP_C  + M_C  + NN_C  + N_C
                                                           + first_C + prev.rewarded_C
                                                           + NP_C:first_C  + M_C:first_C  + NN_C:first_C  + N_C:first_C 
                                                           #+NP_C:prev.rewarded_C  +M_C:prev.rewarded_C +NN_C:prev.rewarded_C +N_C:prev.rewarded_C 
                                                           ,random= ~ ID:us(cuetype.factor), data= data.5cues_univar,  rcov= ~ units, maxiter = 2000,  family=asreml.binomial(link='logit')  , na.method.X= "include" )      
                   #  did not converge
            
               
                summary( model.CJB.5cues.asreml.univ_full.b, all=TRUE)$coef.fixed ;    summary( model.CJB.5cues.asreml.univ_full.c, all=TRUE)$coef.fixed  
                 



   #  Run order *cue.type , prev rewarded  :
#_____________________________________________________

    model.CJB.5cues.asreml.univ_full.a <- asreml(fixed=Approached ~  1 +F_C
                                                     + NP_C  + M_C  + NN_C  + N_C
                                                     + run.order_C + prev.rewarded_C
                                                     + NP_C:run.order_C  + M_C:run.order_C  + NN_C:run.order_C  + N_C:run.order_C
                                                     #+NP_C:prev.rewarded_C  +M_C:prev.rewarded_C +NN_C:prev.rewarded_C +N_C:prev.rewarded_C 
                                                     ,random= ~ ID:idv(cuetype.factor), data= data.5cues_univar,  rcov= ~ units, maxiter = 200,  family=asreml.binomial(link='logit') , na.method.X= "include" ) 
        
        model.CJB.5cues.asreml.univ_full.b <-asreml(fixed=Approached ~  1 +F_C
                                                    + NP_C  + M_C  + NN_C  + N_C
                                                    + run.order_C + prev.rewarded_C
                                                    + NP_C:run.order_C  + M_C:run.order_C  + NN_C:run.order_C  + N_C:run.order_C
                                                    #+NP_C:prev.rewarded_C  +M_C:prev.rewarded_C +NN_C:prev.rewarded_C +N_C:prev.rewarded_C 
                                                    ,random= ~ ID:idh(cuetype.factor), data= data.5cues_univar,  rcov= ~ units, maxiter = 200,  family=asreml.binomial(link='logit')  , na.method.X= "include" ) 
        
        model.CJB.5cues.asreml.univ_full.c <-asreml(fixed=Approached ~  1 +F_C 
                                                    + NP_C  + M_C  + NN_C  + N_C
                                                    + run.order_C + prev.rewarded_C
                                                    + NP_C:run.order_C  + M_C:run.order_C  + NN_C:run.order_C  + N_C:run.order_C
                                                    #+NP_C:prev.rewarded_C  +M_C:prev.rewarded_C +NN_C:prev.rewarded_C +N_C:prev.rewarded_C 
                                                    ,random= ~ ID:us(cuetype.factor), data= data.5cues_univar,  rcov= ~ units, maxiter = 2000,  family=asreml.binomial(link='logit')  , na.method.X= "include" )      
        #  did not converge
        
        
        summary( model.CJB.5cues.asreml.univ_full.b, all=TRUE)$coef.fixed ;    summary( model.CJB.5cues.asreml.univ_full.c, all=TRUE)$coef.fixed  
        
        
        
#____________________________


# B)  without Sex (to increase sample size):      
   
        
            #  first*cue.type, prev rewarded    
    
          model.CJB.5cues.asreml.univ_1a <-   asreml(fixed=Approached ~  1 
                                               + NP_C  + M_C  + NN_C  + N_C
                                               + first_C + prev.rewarded_C
                                               + NP_C:first_C  + M_C:first_C  + NN_C:first_C  + N_C:first_C 
                                              # +NP_C:prev.rewarded_C  +M_C:prev.rewarded_C +NN_C:prev.rewarded_C +N_C:prev.rewarded_C 
                                               ,random= ~ ID:idv(cuetype.factor), data= data.5cues_univar,  rcov= ~ units, maxiter = 20,  family=asreml.binomial(link='logit')   ) 
    
        model.CJB.5cues.asreml.univ_1b <-   asreml(fixed=Approached ~  1 
                                                   + NP_C  + M_C  + NN_C  + N_C
                                                   + first_C + prev.rewarded_C
                                                   + NP_C:first_C  + M_C:first_C  + NN_C:first_C  + N_C:first_C 
                                                   #+NP_C:prev.rewarded_C  +M_C:prev.rewarded_C +NN_C:prev.rewarded_C +N_C:prev.rewarded_C 
                                                   ,random= ~ ID:idh(cuetype.factor), data= data.5cues_univar,  rcov= ~ units, maxiter = 20,  family=asreml.binomial(link='logit')   ) 
    
    
        model.CJB.5cues.asreml.univ_1c <-   asreml(fixed=Approached ~  1
                                                   + NP_C  + M_C  + NN_C  + N_C
                                                   + first_C + prev.rewarded_C
                                                   + NP_C:first_C  + M_C:first_C  + NN_C:first_C  + N_C:first_C 
                                                  #+NP_C:prev.rewarded_C  +M_C:prev.rewarded_C +NN_C:prev.rewarded_C +N_C:prev.rewarded_C 
                                                   ,random= ~ ID:us(cuetype.factor), data= data.5cues_univar,  rcov= ~ units, maxiter = 2000,  family=asreml.binomial(link='logit')   ) 
        
        #  did not converge
    
    
        
   
  #_________________________________________
    
  #  Run order  *cue.type    + prev rewarded  
    
    model.CJB.5cues.asreml.univ_full.a <- asreml(fixed=Approached ~  1 
                                                 + NP_C  + M_C  + NN_C  + N_C
                                                 + run.order_C + prev.rewarded_C
                                                 + NP_C:run.order_C  + M_C:run.order_C  + NN_C:run.order_C  + N_C:run.order_C
                                              
                                                 ,random= ~ ID:idv(cuetype.factor), data= data.5cues_univar,  rcov= ~ units, maxiter = 200,  family=asreml.binomial(link='logit') , na.method.X= "include" ) 
    
    model.CJB.5cues.asreml.univ_full.b <-asreml(fixed=Approached ~  1 
                                                + NP_C  + M_C  + NN_C  + N_C
                                                + run.order_C + prev.rewarded_C
                                                + NP_C:run.order_C  + M_C:run.order_C  + NN_C:run.order_C  + N_C:run.order_C
                                                
                                                ,random= ~ ID:idh(cuetype.factor), data= data.5cues_univar,  rcov= ~ units, maxiter = 200,  family=asreml.binomial(link='logit')  , na.method.X= "include" ) 
    
    model.CJB.5cues.asreml.univ_full.c <-asreml(fixed=Approached ~  1 
                                                + NP_C  + M_C  + NN_C  + N_C
                                                + run.order_C + prev.rewarded_C
                                                + NP_C:run.order_C  + M_C:run.order_C  + NN_C:run.order_C  + N_C:run.order_C
                                                
                                                ,random= ~ ID:us(cuetype.factor), data= data.5cues_univar,  rcov= ~ units, maxiter = 3000,  family=asreml.binomial(link='logit')  , na.method.X= "include" )      
    # US variance structures were modified in 2490 instances to make them positive definite
    
    
    
    summary( model.CJB.5cues.asreml.univ_full.b, all=TRUE)$coef.fixed 
        summary( model.CJB.5cues.asreml.univ_full.c, all=TRUE)$coef.fixed  
    
  
   summary( model.CJB.5cues.asreml.univ_full.a, all=TRUE)$varcomp 
    summary( model.CJB.5cues.asreml.univ_full.b, all=TRUE)$varcomp 
    summary( model.CJB.5cues.asreml.univ_full.c, all=TRUE)$varcomp  

 #   
info.crit.asreml (    model.CJB.5cues.asreml.univ_full.a) # AIC= 23747*
info.crit.asreml (    model.CJB.5cues.asreml.univ_full.b) # AIC= 24280
info.crit.asreml (    model.CJB.5cues.asreml.univ_full.c) # AIC=   27361 



 # Repetabilities on latent scale

# model a    
nadiv:::pin(  model.CJB.5cues.asreml.univ_full.a, R~ V1/(V1+3.29) )  # R =  0.34 +- 0.02 

# model b (without correlations)
nadiv:::pin(  model.CJB.5cues.asreml.univ_full.b , R~ V1/(V1+3.29) )  # Rpo =  0.48 +- 0.04     
nadiv:::pin(  model.CJB.5cues.asreml.univ_full.b , R~ V5/(V5+3.29) )  # Rnp =   0.32 +- 0.08    
nadiv:::pin(  model.CJB.5cues.asreml.univ_full.b , R~ V4/(V4+3.29) )  # Rm =    0.27 +- 0.06
nadiv:::pin(  model.CJB.5cues.asreml.univ_full.b , R~ V3/(V3+3.29) )  # Rnn =   0.21 +- 0.04
nadiv:::pin(  model.CJB.5cues.asreml.univ_full.b , R~ V2/(V2+3.29) )  # Rn =    0.34 +- 0.03

# model c (with correlations bw cues)
nadiv:::pin(  model.CJB.5cues.asreml.univ_full.c , R~ V1/(V1+3.29) )  # Rpo =   0.58 +- 0.04 
nadiv:::pin(  model.CJB.5cues.asreml.univ_full.c , R~ V15/(V15+3.29) )  # Rnp =   0.55 +- 0.07    
nadiv:::pin(  model.CJB.5cues.asreml.univ_full.c , R~ V10/(V10+3.29) )  # Rm =    0.44 +- 0.05
nadiv:::pin(  model.CJB.5cues.asreml.univ_full.c , R~ V6/(V6+3.29) )  # Rnn =   0.35 +- 0.04 
nadiv:::pin(  model.CJB.5cues.asreml.univ_full.c , R~ V3/(V3+3.29) )  # Rn =    0.36 +- 0.03 

# r bw cues
nadiv:::pin(  model.CJB.5cues.asreml.univ_full.c , r~ V11/sqrt(V1*V15) )  # r po-np = 0.99 +- 0.08
nadiv:::pin(  model.CJB.5cues.asreml.univ_full.c , r~ V14 /sqrt(V10 *V15 ) )  # r np-m = 0.93+-0.13
nadiv:::pin(  model.CJB.5cues.asreml.univ_full.c , r~ V9/sqrt(V10 *V6 ) )  # r m-nn = 0.96+-0.11
nadiv:::pin(  model.CJB.5cues.asreml.univ_full.c , r~ V5 /sqrt(V6 *V3 ) )  # r nn-n = 0.96+-0.07
  nadiv:::pin(  model.CJB.5cues.asreml.univ_full.c , r~ V7 /sqrt(V1 *V10) )  # r po-m = 0.88+-0.08
  nadiv:::pin(  model.CJB.5cues.asreml.univ_full.c , r~ V4 /sqrt(V1 *V6) )  # r po-nn = 0.81+-0.10
  nadiv:::pin(  model.CJB.5cues.asreml.univ_full.c , r~ V2 /sqrt(V1 *V3) )  # r po-n = 0.77+-0.07
  nadiv:::pin(  model.CJB.5cues.asreml.univ_full.c , r~ V13 /sqrt(V15 *V6) )  # r np-nn = 0.87+-0.15
  nadiv:::pin(  model.CJB.5cues.asreml.univ_full.c , r~ V12 /sqrt(V15 *V3) )  # r np-n = 0.81+-0.11
  nadiv:::pin(  model.CJB.5cues.asreml.univ_full.c , r~ V8 /sqrt(V10 *V3) )  # r m-n = 0.86+-0.08
  
  
#____________   
 #    G   ***
#____________      
                
animalmodel.CJB.5cues.asreml.univ_1 <-   asreml(fixed=Approached ~ 1 +F_C 
                                              +NP_C*run.order_C + M_C*run.order_C  + NN_C*run.order_C   +N_C*run.order_C   
                                              +prev.rewarded_C 
                                                   ,random =~  ped (ID, var=T) +ide (ID, var=T)   ,  ginverse=list(ID=ainv),   rcov= ~ units, data= data.5cues_univar , maxiter = 200,  family=asreml.binomial(link='logit')  , na.method.X = "include" ) 
  

animalmodel.CJB.5cues.asreml.univ_1a <-   asreml(fixed=Approached ~ 1 +F_C
                                               +NP_C*run.order_C + M_C*run.order_C  + NN_C*run.order_C   +N_C*run.order_C  
                                               +prev.rewarded_C 
                                               ,random =~  ped (ID, var=T):idv(cuetype.factor)  +ide (ID, var=T):idv(cuetype.factor)   ,  ginverse=list(ID=ainv),   rcov= ~ units, data= data.5cues_univar , maxiter = 200,  family=asreml.binomial(link='logit')  , na.method.X = "include" ) 

animalmodel.CJB.5cues.asreml.univ_1b <-   asreml(fixed=Approached ~ 1 +F_C
                                               +NP_C*run.order_C + M_C*run.order_C  + NN_C*run.order_C   +N_C*run.order_C   
                                               +prev.rewarded_C 
                                               ,random =~  ped (ID, var=T):idh(cuetype.factor)  +ide (ID, var=T):idh(cuetype.factor)   ,  ginverse=list(ID=ainv),   rcov= ~ units, data= data.5cues_univar , maxiter = 200,  family=asreml.binomial(link='logit') , na.method.X = "include"  ) 

  animalmodel.CJB.5cues.asreml.univ_1c <-   asreml(fixed=Approached ~ 1 +F_C
                                                   +NP_C*run.order_C + M_C*run.order_C  + NN_C*run.order_C   +N_C*run.order_C   
                                                   +prev.rewarded_C 
                                                   ,random =~  ped (ID, var=T):us(cuetype.factor)  +ide (ID, var=T):us(cuetype.factor)   ,  ginverse=list(ID=ainv),   rcov= ~ units, data= data.5cues_univar , maxiter = 2000,  family=asreml.binomial(link='logit')  , na.method.X = "include" ) 
                                 

  
    summary(animalmodel.CJB.5cues.asreml.univ_1  )
  summary(animalmodel.CJB.5cues.asreml.univ_1a  )
  summary(animalmodel.CJB.5cues.asreml.univ_1b  )         
  summary(animalmodel.CJB.5cues.asreml.univ_1c  )         
  
        info.crit.asreml (animalmodel.CJB.5cues.asreml.univ_1) #  # AIC= 27048     
    info.crit.asreml (animalmodel.CJB.5cues.asreml.univ_1a) # AIC= 23856*
    info.crit.asreml (animalmodel.CJB.5cues.asreml.univ_1b) # AIC= 24517
    info.crit.asreml (animalmodel.CJB.5cues.asreml.univ_1c) # AIC= 27643
    
 
    
    
    # without Sex:
            
            
            animalmodel.CJB.5cues.asreml.univ_1 <-   asreml(fixed=Approached ~ 1 
                                                            +NP_C*run.order_C + M_C*run.order_C  + NN_C*run.order_C   +N_C*run.order_C   
                                                            +prev.rewarded_C 
                                                            ,random =~  ped (ID, var=T) +ide (ID, var=T)   ,  ginverse=list(ID=ainv),   rcov= ~ units, data= data.5cues_univar , maxiter = 200,  family=asreml.binomial(link='logit')  , na.method.X = "include" ) 
            
            
            animalmodel.CJB.5cues.asreml.univ_1a <-   asreml(fixed=Approached ~ 1
                                                             +NP_C*run.order_C + M_C*run.order_C  + NN_C*run.order_C   +N_C*run.order_C  
                                                             +prev.rewarded_C 
                                                             ,random =~  ped (ID, var=T):idv(cuetype.factor)  +ide (ID, var=T):idv(cuetype.factor)   ,  ginverse=list(ID=ainv),   rcov= ~ units, data= data.5cues_univar , maxiter = 200,  family=asreml.binomial(link='logit')  , na.method.X = "include" ) 
            
            animalmodel.CJB.5cues.asreml.univ_1b <-   asreml(fixed=Approached ~ 1
                                                             +NP_C*run.order_C + M_C*run.order_C  + NN_C*run.order_C   +N_C*run.order_C   
                                                             +prev.rewarded_C 
                                                             ,random =~  ped (ID, var=T):idh(cuetype.factor)  +ide (ID, var=T):idh(cuetype.factor)   ,  ginverse=list(ID=ainv),   rcov= ~ units, data= data.5cues_univar , maxiter = 200,  family=asreml.binomial(link='logit') , na.method.X = "include"  ) 
            
            animalmodel.CJB.5cues.asreml.univ_1c <-   asreml(fixed=Approached ~ 1
                                                             +NP_C*run.order_C + M_C*run.order_C  + NN_C*run.order_C   +N_C*run.order_C   
                                                             +prev.rewarded_C 
                                                             ,random =~  ped (ID, var=T):us(cuetype.factor)  +ide (ID, var=T):us(cuetype.factor)   ,  ginverse=list(ID=ainv),   rcov= ~ units, data= data.5cues_univar , maxiter = 2000,  family=asreml.binomial(link='logit')  , na.method.X = "include" ) 
                  #  
            
          
            summary(animalmodel.CJB.5cues.asreml.univ_1  )
          summary(animalmodel.CJB.5cues.asreml.univ_1a  )
          summary(animalmodel.CJB.5cues.asreml.univ_1b  )         
          summary(animalmodel.CJB.5cues.asreml.univ_1c  )         
    
            info.crit.asreml (animalmodel.CJB.5cues.asreml.univ_1) #  # AIC=   27037   
          info.crit.asreml (animalmodel.CJB.5cues.asreml.univ_1a) # AIC= 23833*
          info.crit.asreml (animalmodel.CJB.5cues.asreml.univ_1b) # AIC= 24501
          info.crit.asreml (animalmodel.CJB.5cues.asreml.univ_1c) # AIC=  27645
       
   #________________________________ 
    
    
    # h2
          
          #   on latent scale
          
          # model a *   
          nadiv:::pin(animalmodel.CJB.5cues.asreml.univ_1a  , h2~ V1/(V1+V2 + 3.29) )  # h2 =  0.09 +- 0.04 *
          nadiv:::pin(animalmodel.CJB.5cues.asreml.univ_1a  , h2~ V2/(V1+V2 + 3.29) )  # e2 =   0.26 +- 0.04 **
          
          # model b (without correlations)
          nadiv:::pin(  animalmodel.CJB.5cues.asreml.univ_1b , h2~ V1/(V1+V6+3.29) )  # h2po =  0.32 +- 0.16 *   <===<<
          nadiv:::pin(  animalmodel.CJB.5cues.asreml.univ_1b , e2~ V6/(V1+V6+3.29) )  # e2po =  0.19 +- 0.14
          
          nadiv:::pin( animalmodel.CJB.5cues.asreml.univ_1b , h2~ V5/(V5+V10+3.29) )  # h2np =    0.27 +- 0.22
          nadiv:::pin( animalmodel.CJB.5cues.asreml.univ_1b , e2~ V10/(V5+V10+3.29) )  # e2np =    0.08 +- 0.20
          
          nadiv:::pin( animalmodel.CJB.5cues.asreml.univ_1b , h2~ V4/(V4+V9+3.29) )  # h2m =     0.07 +- 0.11
          nadiv:::pin( animalmodel.CJB.5cues.asreml.univ_1b , e2~ V9/(V4+V9+3.29) )  # e2m =     0.21 +- 0.11    <==<<
          
          nadiv:::pin(  animalmodel.CJB.5cues.asreml.univ_1b , h2~ V3/(V3+V8+3.29) )  # h2nn =   0.06 +- 0.07
          nadiv:::pin(  animalmodel.CJB.5cues.asreml.univ_1b , e2~ V8/(V3+V8+3.29) )  # e2nn =   0.16 +- 0.07 * <=====<<
          
          nadiv:::pin( animalmodel.CJB.5cues.asreml.univ_1b , h2~ V2/(V2+V7+3.29) )  # h2n =    0.02 +- 0.04
          nadiv:::pin( animalmodel.CJB.5cues.asreml.univ_1b , e2~ V7/(V2+V7+3.29) )  # e2n =    0.32 +- 0.05 **   <=======<<
          
          # model c (with correlations bw cues)
           .....
          
       
    


    
    
#______________________________________________________________________________



#|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

#:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::####
#     II. only AMBIGUOUS => 3 CUES *** ####
#:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::####          

# note SEX not fitted since already found NS in 5-cues models



  library ('dplyr') 
  
  data.CJB_ambiguous <- subset (data.CJB, data.CJB$cue.type== 'NP' | data.CJB$cue.type== 'M' | data.CJB$cue.type== 'NN' )                  
  match<- paste(data.CJB_ambiguous$ID, data.CJB_ambiguous$cue.type)
  data.CJB_ambiguous <-  data.frame (data.CJB_ambiguous, match=match)
  data.CJB_ambiguous <-  data.CJB_ambiguous%>% group_by(match) %>% mutate(replicate = 1:n())   
  View(data.CJB_ambiguous)
  
  ID <- as.factor(data.CJB_ambiguous$ID )
  sex  <-data.CJB_ambiguous$sex;   F <- as.numeric (sex=="F") 
 year  <-data.CJB_ambiguous$year;   yr2015 <- as.numeric (year==2015); yr2016 <- as.numeric (year==2016); yr2017 <- as.numeric (year==2017)
      rewarded.white <- as.numeric(as.character (data.CJB_ambiguous $rewarded.white))
run.order <- data.CJB_ambiguous $run.order
  order.cat<- data.CJB_ambiguous$replicate; first <- as.numeric (order.cat ==1)
cue.type <- data.CJB_ambiguous $ cue.type; NP <- as.numeric (cue.type =='NP') ;  M<- as.numeric (cue.type =='M')   ;  NN <- as.numeric (cue.type =='NN') 
  
  prev.rewarded <-data.CJB_ambiguous$Prev.rewarded
  
  Latency <-data.CJB_ambiguous $Latency
  Approached <- data.CJB_ambiguous $Approached
  
  
    F_C <-  (F -mean(F, na.rm=TRUE))
  yr2015_C <- yr2015 -mean(yr2015);  yr2016_C <- yr2016 -mean(yr2016) ;  yr2017_C <- yr2017 -mean(yr2017)
    rewarded.white_C <- (rewarded.white -mean(rewarded.white, na.rm=T))
  prev.rewarded_C<- (prev.rewarded-mean(prev.rewarded, na.rm=T))
    first_C  <- ( first-mean(first, na.rm=T))
  run.order_C  <- (run.order-mean(run.order, na.rm=T)) / (2*sd(run.order, na.rm=T)) 
  M_C <- ( M -mean( M, na.rm=T));     NN_C  <- (NN -mean(NN, na.rm=T))
  prev.rewarded.factor<- as.factor(prev.rewarded)
  cuetype.factor<-as.factor(paste( NP, M, NN))
  cuetype_rewarded <- as.factor(paste(cuetype.factor,"_", prev.rewarded.factor ))
  

hist(Latency)
  
  Latency_tr1 <- log (Latency+1)
  Latency_tr2 <- -1/(Latency+1)
  
  
      
      
      
      
data.3ambiguouscues_univar<- data.frame( ID, F_C, yr2015_C, yr2016_C, yr2017_C,  cue.type, M_C, NN_C,   run.order_C , first_C, prev.rewarded_C, prev.rewarded.factor, cuetype.factor,   Approached, Latency_tr1, Latency_tr2  )   
      
      
       # using "first exposure vs re-exposure":
      #__________________________________________________
      
        model.CJB.3ambiguouscues.asreml.univ_full <-   asreml(fixed=Approached ~  1  
                                                              +  M_C + NN_C 
                                                              + prev.rewarded_C*M_C + prev.rewarded_C*NN_C  
                                                              + first_C*M_C+ first_C*NN_C
                                                              ,random= ~ ID, data= data.3ambiguouscues_univar,  rcov= ~ units, maxiter = 20,  family=asreml.binomial(link='logit')   )   # 
       
         summary(model.CJB.3ambiguouscues.asreml.univ_full , all=TRUE)$coef.fixed
         summary(model.CJB.3ambiguouscues.asreml.univ_full , all=TRUE)$varcomp
         #  NB: first exposure vs re-exposure  = NS (if fitted as main effect without interaction with cue: zratio=1.82)  <=======================================<<
        
            model.CJB.3ambiguouscues.asreml.univ_1a <-   asreml(fixed=Approached ~  1    
                                                                + M_C + NN_C 
                                                                + first_C
                                                                + prev.rewarded_C
                                                                ,random= ~ ID:idv(cuetype.factor), data= data.3ambiguouscues_univar,  rcov= ~ units, maxiter = 20,  family=asreml.binomial(link='logit')   )   # 
            
            model.CJB.3ambiguouscues.asreml.univ_1b <-   asreml(fixed=Approached ~  1   
                                                        + M_C + NN_C 
                                                        + first_C
                                                        + prev.rewarded_C
                                                        ,random= ~ ID:idh(cuetype.factor), data= data.3ambiguouscues_univar,  rcov= ~ units, maxiter = 20,  family=asreml.binomial(link='logit')   )   # 
          
           model.CJB.3ambiguouscues.asreml.univ_1c <-   asreml(fixed=Approached ~  1   
                                                               +  M_C + NN_C
                                                               + first_C
                                                               + prev.rewarded_C
                                                            ,random= ~ ID:us(cuetype.factor), data= data.3ambiguouscues_univar,  rcov= ~ units, maxiter = 2000,  family=asreml.binomial(link='logit')   )   
              # not converged
                  

     
           
# using run order:
#________________________________



    model.CJB.3ambiguouscues.asreml.univ_full <-   asreml(fixed=Approached ~  1  
                                                       +  M_C + NN_C 
                                                       + prev.rewarded_C*M_C + prev.rewarded_C*NN_C  
                                                       + run.order_C*M_C+ run.order_C*NN_C
                                                       ,random= ~ ID, data= data.3ambiguouscues_univar,  rcov= ~ units, maxiter = 20,  family=asreml.binomial(link='logit')   )   # 
    
    summary(model.CJB.3ambiguouscues.asreml.univ_full , all=TRUE)$coef.fixed
    summary(model.CJB.3ambiguouscues.asreml.univ_full , all=TRUE)$varcomp

model.CJB.3ambiguouscues.asreml.univ_1 <-   asreml(fixed=Approached ~  1    
                                                    + M_C + NN_C 
                                                    + run.order_C
                                                    + prev.rewarded_C
                                                    ,random= ~ ID, data= data.3ambiguouscues_univar,  rcov= ~ units, maxiter = 20,  family=asreml.binomial(link='logit')   )   # 

model.CJB.3ambiguouscues.asreml.univ_1a <-   asreml(fixed=Approached ~  1    
                                                 + M_C + NN_C 
                                                 + run.order_C
                                                 + prev.rewarded_C
                                                 ,random= ~ ID:idv(cuetype.factor), data= data.3ambiguouscues_univar,  rcov= ~ units, maxiter = 20,  family=asreml.binomial(link='logit')   )   # 

model.CJB.3ambiguouscues.asreml.univ_1b <-   asreml(fixed=Approached ~  1   
                                                 + M_C + NN_C 
                                                 + run.order_C
                                                 + prev.rewarded_C
                                                 ,random= ~ ID:idh(cuetype.factor), data= data.3ambiguouscues_univar,  rcov= ~ units, maxiter = 20,  family=asreml.binomial(link='logit')   )   # 

model.CJB.3ambiguouscues.asreml.univ_1c <-   asreml(fixed=Approached ~  1   
                                                 +  M_C + NN_C
                                                 +  run.order_C
                                                 + prev.rewarded_C
                                                 ,random= ~ ID:us(cuetype.factor), data= data.3ambiguouscues_univar,  rcov= ~ units, maxiter = 2000,  family=asreml.binomial(link='logit')   )   
# 

summary(model.CJB.3ambiguouscues.asreml.univ_1a , all=TRUE)$coef.fixed
summary(model.CJB.3ambiguouscues.asreml.univ_1b , all=TRUE)$coef.fixed
summary(model.CJB.3ambiguouscues.asreml.univ_1c , all=TRUE)$coef.fixed

summary(model.CJB.3ambiguouscues.asreml.univ_1a , all=TRUE)$varcomp
summary(model.CJB.3ambiguouscues.asreml.univ_1b , all=TRUE)$varcomp
summary(model.CJB.3ambiguouscues.asreml.univ_1c , all=TRUE)$varcomp

   
  info.crit.asreml (    model.CJB.3ambiguouscues.asreml.univ_1) # AIC=6209
info.crit.asreml (    model.CJB.3ambiguouscues.asreml.univ_1a) # AIC=5704*
info.crit.asreml (    model.CJB.3ambiguouscues.asreml.univ_1b) # AIC= 5705*
info.crit.asreml (    model.CJB.3ambiguouscues.asreml.univ_1c) # AIC= 6344



# Repetabilities on latent scale

# model a    
nadiv:::pin(   model.CJB.3ambiguouscues.asreml.univ_1a, R~ V1/(V1+3.29) )  # R =  0.24 +- 0.03

# model b (without correlations)
nadiv:::pin(  model.CJB.3ambiguouscues.asreml.univ_1b, R~ V3/(V3+3.29) )  # Rnp =  0.32 +-0.08
nadiv:::pin(   model.CJB.3ambiguouscues.asreml.univ_1b, R~ V2/(V2+3.29) )  # Rm =  0.27  +- 0.06
nadiv:::pin(   model.CJB.3ambiguouscues.asreml.univ_1b, R~ V1/(V1+3.29) )  # Rnn =   0.20 +- 0.04


# model c (with correlations bw cues)
nadiv:::pin(  model.CJB.3ambiguouscues.asreml.univ_1c, R~ V6/(V6+3.29) )  # Rnp =   0.46 +- 0.08   
nadiv:::pin(  model.CJB.3ambiguouscues.asreml.univ_1c , R~ V3/(V3+3.29) )  # Rm =  0.39 +- 0.06
nadiv:::pin(   model.CJB.3ambiguouscues.asreml.univ_1c , R~ V1/(V1+3.29) )  # Rnn =  0.26  +- 0.05  

# r bw cues
nadiv:::pin(  model.CJB.3ambiguouscues.asreml.univ_1c , r~ V5 /sqrt(V6*V3 ) )  # r np-m = 0.99 +-0.15 
nadiv:::pin(   model.CJB.3ambiguouscues.asreml.univ_1c, r~ V2/sqrt(V1 *V3 ) )  # r m-nn =  0.99 +-0.14
nadiv:::pin( model.CJB.3ambiguouscues.asreml.univ_1c, r~ V4 /sqrt(V1 *V6) )  # r np-nn =   0.97 +-0.19




#__________
# G
#__________
      
animalmodel.CJB.3ambiguouscues.asreml.univ_1  <- asreml(fixed=Approached ~  1   
                                                          + M_C + NN_C 
                                                           +  run.order_C
                                                          + prev.rewarded_C
                                                  ,random =~  ped (ID, var=T) +ide (ID, var=T),  ginverse=list(ID=ainv) ,data= data.3ambiguouscues_univar,  rcov= ~ units, maxiter = 20,  family=asreml.binomial(link='logit')   )   # 




                  animalmodel.CJB.3ambiguouscues.asreml.univ_1gauss  <-   asreml(fixed=Approached ~  1    + M_C + NN_C + prev.rewarded_C +  run.order_C
                                                                          ,random =~  ped (ID, var=T) +ide (ID, var=T),  ginverse=list(ID=ainv) ,
                                                                           data= data.3ambiguouscues_univar,  rcov= ~ units, maxiter = 20  )   # 
                  
                  
                  
      
  animalmodel.CJB.3ambiguouscues.asreml.univ_1a <-   asreml(fixed=Approached ~  1    
                                                                  + M_C + NN_C 
                                                                  +  run.order_C
                                                                  + prev.rewarded_C
                                                    ,random =~  ped (ID, var=T):idv(cuetype.factor) +ide (ID, var=T):idv(cuetype.factor)  ,  ginverse=list(ID=ainv) ,data= data.3ambiguouscues_univar,  rcov= ~ units, maxiter = 20,  family=asreml.binomial(link='logit')   )   # 
        

        
                
  animalmodel.CJB.3ambiguouscues.asreml.univ_1b <-   asreml(fixed=Approached ~  1   
                                                                + M_C + NN_C 
                                                                +  run.order_C
                                                                + prev.rewarded_C
                                                   ,random =~  ped (ID, var=T):idh(cuetype.factor) +ide (ID, var=T):idh(cuetype.factor)  ,  ginverse=list(ID=ainv) ,data= data.3ambiguouscues_univar,  rcov= ~ units, maxiter = 20,  family=asreml.binomial(link='logit')   )   # 
     

                
  animalmodel.CJB.3ambiguouscues.asreml.univ_1c <-   asreml(fixed=Approached ~  1 
                                                             + M_C + NN_C 
                                                              +  run.order_C
                                                              +prev.rewarded_C
                                                            ,random =~  ped (ID, var=T):us(cuetype.factor) +ide (ID, var=T):us(cuetype.factor)  ,  ginverse=list(ID=ainv) ,data= data.3ambiguouscues_univar,  rcov= ~ units, maxiter = 3000,  family=asreml.binomial(link='logit')   )   # 
                   # NOT CONVERGING
     
      
  summary(  animalmodel.CJB.3ambiguouscues.asreml.univ_1 , all=TRUE)$varcomp
  summary(  animalmodel.CJB.3ambiguouscues.asreml.univ_1a , all=TRUE)$varcomp 
  summary(  animalmodel.CJB.3ambiguouscues.asreml.univ_1b , all=TRUE)$varcomp
  summary(  animalmodel.CJB.3ambiguouscues.asreml.univ_1c , all=TRUE)$varcomp
    
    
  info.crit.asreml (   animalmodel.CJB.3ambiguouscues.asreml.univ_1) # AIC=6220
  info.crit.asreml (   animalmodel.CJB.3ambiguouscues.asreml.univ_1a) # AIC= 5718 *
  info.crit.asreml (   animalmodel.CJB.3ambiguouscues.asreml.univ_1b) # AIC=   5752    
  info.crit.asreml (   animalmodel.CJB.3ambiguouscues.asreml.univ_1c) # AIC=   6334 (not converged)   


  
  #________________________________ 
  
  # h2
  
  
  #   on latent scale
  
  # model a *   
  nadiv:::pin(  animalmodel.CJB.3ambiguouscues.asreml.univ_1a , h2~ V1 /(V1 +V2  + 3.29) )  # h2 = 0.09+-0.06
  nadiv:::pin(   animalmodel.CJB.3ambiguouscues.asreml.univ_1a , e2~ V2 /(V1 +V2  + 3.29) )  # e2 =  0.16 +-0.06 *
  
  # model b (without correlations)
  
  nadiv:::pin(   animalmodel.CJB.3ambiguouscues.asreml.univ_1b , h2~ V3 /(V3 +V6 +3.29) )  # h2np =   0.28+-0.22
  nadiv:::pin(   animalmodel.CJB.3ambiguouscues.asreml.univ_1b , e2~ V6 /(V3 +V6 +3.29) )  # e2np =  0.07+-0.20
  
  nadiv:::pin(  animalmodel.CJB.3ambiguouscues.asreml.univ_1b , h2~ V2 /(V2 +V5 +3.29) )  # h2m =    0.08+-0.11
  nadiv:::pin(   animalmodel.CJB.3ambiguouscues.asreml.univ_1b , e2~ V5 /(V2 +V5 +3.29) )  # e2m =    0.20+-0.11 
  
  nadiv:::pin(   animalmodel.CJB.3ambiguouscues.asreml.univ_1b , h2~ V1 /(V1 +V4 +3.29) )  # h2nn =   0.05+-0.07
  nadiv:::pin(  animalmodel.CJB.3ambiguouscues.asreml.univ_1b , e2~ V4 /(V1 +V4 +3.29) )  # e2nn =    0.15+-0.7 *
  
  
  # model c (with correlations bw cues)
  .....
  
  
  
  
  
  #  ambiguous pooled <===<<
  
  nadiv:::pin(  model.CJB.3ambiguouscues.asreml.univ_1, h2~ V1 /(V1   + 3.29) )  # R = 0.34 +-0.03
  
  nadiv:::pin(  animalmodel.CJB.3ambiguouscues.asreml.univ_1 , h2~ V1 /(V1 +V2  + 3.29) )  # h2 = 0.09 +-0.07
  nadiv:::pin(   animalmodel.CJB.3ambiguouscues.asreml.univ_1 , e2~ V2 /(V1 +V2  + 3.29) )  # e2 =  0.26 +-0.07 ** 

      

#___________________________________________________________________________________________________________________________        



#xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

                        
                        
#|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||| ####    
                        
# => within Approaching:      LATENCY TO APPROACH **** ####  
                        
#|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||| ####   

data.CJB_approached <-subset (data.CJB, data.CJB$Latency<30)  # <---------------------  NB: using same time window also for 2014, when max duratin was 60 sec **

ID <- as.factor(data.CJB_approached$ID )
sex<-data.CJB_approached$sex;   F <- as.numeric(sex=="F")

  rewarded.white <- as.numeric(as.character (data.CJB_approached $rewarded.white))
run.order <- data.CJB_approached $run.order
  order.cat <- data.CJB_approached$order;  first<- as.numeric (order.cat ==1)        
cue.type <- data.CJB_approached$ cue.type; NP <- as.numeric (cue.type =='NP') ;  M<- as.numeric (cue.type =='M')   ;  NN <- as.numeric (cue.type =='NN') ;    N<- as.numeric (cue.type =='N' | cue.type =='N ') 
prev.rewarded <-data.CJB_approached $ Prev.rewarded

Latency <-data.CJB_approached $Latency
Latency_tr <- log(Latency+1);   Latency_tr2 <-     - 1/(Latency+1)  # <---<<
hist(Latency_tr) ; hist(Latency_tr2)

F_C <-  (F -mean(F, na.rm=TRUE))

   rewarded.white_C <- (rewarded.white -mean(rewarded.white))
prev.rewarded_C<- (prev.rewarded-mean(prev.rewarded))
run.order_C  <- (run.order-mean(run.order)) / (2*sd(run.order)) 
first_C  <- ( first-mean(first)) 
NP_C  <- (NP -mean(NP));     M_C <- ( M -mean( M));     NN_C  <- (NN -mean(NN));      N_C<- (N -mean(N))

prev.rewarded.factor<- as.factor(prev.rewarded)
cuetype.factor<-as.factor(paste( NP, M, NN, N))



            

#//////////////////////////
#:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::####
# I..............Univariate Models    ####
#:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::####
#//////////////////////////




#OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO


#___________________________________________________________________________####   
#      only AMBIGUOUS (3) cues ***  <======  #### 
#___________________________________________________________________________####             

data.CJB_approached <-subset (data.CJB, data.CJB$Latency<30)  # <---------------------  NB: using same time window also for 2014, when max duratin was 60 sec **

data.CJB_approached.Ambiguous <-subset (data.CJB_approached, data.CJB_approached$cue.type=="NP" |data.CJB_approached$cue.type=="M"|data.CJB_approached$cue.type=="NN")
unique(data.CJB_approached.Ambiguous$cue.type)


ID <- as.factor(data.CJB_approached.Ambiguous$ID )
sex<-data.CJB_approached.Ambiguous$sex;   F <- as.numeric(sex=="F")

rewarded.white <- as.numeric(as.character (data.CJB_approached.Ambiguous $rewarded.white))
run.order <- data.CJB_approached.Ambiguous $run.order
order.cat <- data.CJB_approached.Ambiguous$order;  first<- as.numeric (order.cat ==1)        
cue.type <- data.CJB_approached.Ambiguous$ cue.type; NP <- as.numeric (cue.type =='NP') ;  M<- as.numeric (cue.type =='M')   ;  NN <- as.numeric (cue.type =='NN') 
prev.rewarded <-data.CJB_approached.Ambiguous $ Prev.rewarded

Latency <-data.CJB_approached.Ambiguous $Latency
Latency_tr <- log(Latency+1);   Latency_tr2 <-     - 1/(Latency+1)  # <---<<
hist(Latency_tr) ; hist(Latency_tr2)

F_C <-  (F -mean(F, na.rm=TRUE))

rewarded.white_C <- (rewarded.white -mean(rewarded.white))
prev.rewarded_C<- (prev.rewarded-mean(prev.rewarded))
run.order_C  <- (run.order-mean(run.order)) / (2*sd(run.order)) 
first_C  <- ( first-mean(first)) 
M_C <- ( M -mean( M));     NN_C  <- (NN -mean(NN))

prev.rewarded.factor<- as.factor(prev.rewarded)
cuetype.factor<-as.factor(paste( NP, M, NN))










data.3cues_approached  <- data.frame( ID,F_C,  Latency,  Latency_tr, Latency_tr2, cue.type,  rewarded.white,  rewarded.white_C ,prev.rewarded, prev.rewarded_C,  run.order_C , first_C ,  M_C, NN_C, cuetype.factor, prev.rewarded.factor )   




model.CJB.3cues.asreml.univ_1full <-   asreml(fixed=Latency_tr~  1 +
                                                run.order_C*M_C + run.order_C*NN_C  
                                              + prev.rewarded_C*M_C+ prev.rewarded_C*NN_C
                                              ,random= ~ ID, data= data.3cues_approached ,  rcov= ~ units, maxiter = 200,  family=asreml.gaussian (link='identity')   )  

model.CJB.3cues.asreml.univ_1 <-   asreml(fixed=Latency_tr~  1 +
                                            M_C + NN_C  
                                          +run.order_C
                                          + prev.rewarded_C
                                          ,random= ~ ID, data= data.3cues_approached ,  rcov= ~ units, maxiter = 200,  family=asreml.gaussian (link='identity')   )  


model.CJB.3cues.asreml.univ_1a <-   asreml(fixed=Latency_tr~  1 +
                                             M_C + NN_C  
                                           +run.order_C
                                           + prev.rewarded_C
                                           ,random= ~ ID:idv(cuetype.factor), data= data.3cues_approached ,  rcov= ~ units, maxiter = 200,  family=asreml.gaussian (link='identity')   )  


model.CJB.3cues.asreml.univ_1b <-   asreml(fixed=Latency_tr~  1 +
                                             M_C + NN_C  
                                           +run.order_C
                                           + prev.rewarded_C
                                           ,random= ~ ID:idh(cuetype.factor), data= data.3cues_approached ,  rcov= ~ units, maxiter = 200,  family=asreml.gaussian (link='identity')   )  

model.CJB.3cues.asreml.univ_1c <-   asreml(fixed=Latency_tr~  1 +
                                             M_C + NN_C  
                                           +run.order_C
                                           + prev.rewarded_C
                                           ,random= ~ ID:us(cuetype.factor), data= data.3cues_approached ,  rcov= ~ units, maxiter = 200,  family=asreml.gaussian (link='identity')   )  


summary(model.CJB.3cues.asreml.univ_1, all=T)$coef.fixed

summary(model.CJB.3cues.asreml.univ_1, all=T)$varcomp




#//////////// 
# G 
#////////////

animalmodel.CJB.3cues.asreml.univ_1 <-   asreml(fixed=Latency_tr~  1 +
                                                  M_C + NN_C  
                                                +run.order_C
                                                + prev.rewarded_C
                                                ,random= ~  ped (ID, var=T) +ide (ID, var=T) , ginverse=list(ID=ainv) , data= data.3cues_approached ,  rcov= ~ units, maxiter = 200,  family=asreml.gaussian (link='identity')   )  

summary(animalmodel.CJB.3cues.asreml.univ_1, all=T)$varcomp







# REPEATABILITY;   h2,e2

nadiv:::pin(  model.CJB.3cues.asreml.univ_1 , R~ V1/(V1+V2) )  # R = 0.25 +- 0.03

nadiv:::pin(  animalmodel.CJB.3cues.asreml.univ_1 , h2~ V1/(V1+V2+V3) )  # h2 = 0.10  +- 0.06  NS
nadiv:::pin(  animalmodel.CJB.3cues.asreml.univ_1 , e2~ V2/(V1+V2+V3) )  # e2 = 0.16  +- 0.05  *




animalmodel.CJB.3cues.asreml.univ_1 <-   asreml(fixed=Latency_tr~  1 +
                                                  M_C + NN_C  
                                                +run.order_C
                                                + prev.rewarded_C
                                                ,random= ~  ped (ID, var=T) +ide (ID, var=T) , ginverse=list(ID=ainv) , data= data.3cues_approached ,  rcov= ~ units, maxiter = 200,  family=asreml.gaussian (link='identity')   )  

summary(animalmodel.CJB.3cues.asreml.univ_1, all=T)$varcomp



animalmodel.CJB.3cues.asreml.univ_0 <-   asreml(fixed=Latency_tr~  1 +
                                                  M_C + NN_C  
                                                +run.order_C
                                                + prev.rewarded_C
                                                ,random= ~ide (ID, var=T) , ginverse=list(ID=ainv) , data= data.3cues_approached ,  rcov= ~ units, maxiter = 200,  family=asreml.gaussian (link='identity')   )  



reml.lrt.asreml (   animalmodel.CJB.3cues.asreml.univ_1 , animalmodel.CJB.3cues.asreml.univ_0  ) # P=0.07  => /2= 0.04*                   <=================<<






animalmodel.CJB.3cues.asreml.univ_00 <-   asreml(fixed=Latency_tr~  1 +
                                                   M_C + NN_C  
                                                 +run.order_C
                                                 + prev.rewarded_C
                                                 ,data= data.3cues_approached ,  rcov= ~ units, maxiter = 200,  family=asreml.gaussian (link='identity')   )  

reml.lrt.asreml (   animalmodel.CJB.3cues.asreml.univ_0 , animalmodel.CJB.3cues.asreml.univ_00  ) # P<0.01


#___________________

#______________________________________________________________________________________________

            
            
#/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::####
#  MULTIVARIATE MODELS *** ####
# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::####


data.CJB_approached <- subset (data.CJB, data.CJB$Latency <30 )
data.CJB_approached <- data.frame (data.CJB_approached, Latency_tr= log(data.CJB_approached$Latency + 1), Latency_tr2= - 1/(data.CJB_approached$Latency + 1)      )
head(data.CJB_approached)   ; names (data.CJB_approached)  ;  View(data.CJB_approached)

hist( data.CJB_approached$Latency)
hist( data.CJB_approached$Latency_tr)
hist( data.CJB_approached$Latency_tr2)

ID_year_sex <- unique(data.CJB_approached [,c(1,2,19)])  # 

data.common <- data.frame (ID= rep(ID_year_sex[,1], 33) , sex=   rep(ID_year_sex[,3], 33) ,   year=   rep(ID_year_sex[,2], 33)   )
      data.common <- data.common[order(data.common[,1]),]
repetition= rep( 1:33, length(unique(ID_year_sex[,1])  )    )
data.common <- data.frame (data.common, run.order= repetition)
data.common <- data.common [order(data.common[,1],data.common[,2] ) , ]
match <- paste (data.common$ID, "_",  data.common$run.order ) ;  data.common <- data.frame (data.common, match= match)

names(data.CJB_approached)
data.CJB_approached.pruned <- data.CJB_approached [, c(1,2,19,7,   9   ,11,12,16, 20,21)]   # 
              # ID, year, sex, run.order,   cue.type,       first*,  prev.rewarded,     Latency, Latency_tr, Latency_tr2


data.CJB_approached.P <- subset (data.CJB_approached.pruned ,  data.CJB_approached.pruned$cue.type=="P" )  
                      data.CJB_approached.P <- data.CJB_approached.P [, c(1:4, 6:10)]   # removed cue.type (all P)
                      data.CJB_approached.P <- data.frame (data.CJB_approached.P , match = paste (data.CJB_approached.P$ID, "_", data.CJB_approached.P$run.order   )  )
                      names(data.CJB_approached.P )    <- c("ID", "year", "sex",  "run.order", "order.P", "prev.rewarded.P", "latency.P", "Latency_tr.P","Latency_tr2.P", "match")
                      data.CJB_approached.P <- data.CJB_approached.P [, c(1,5:10)]

data.CJB_approached.NP <- subset (data.CJB_approached.pruned ,  data.CJB_approached.pruned$cue.type=="NP" )  
                      data.CJB_approached.NP <- data.CJB_approached.NP [, c(1:4, 6:10)]
                      data.CJB_approached.NP <- data.frame (data.CJB_approached.NP , match = paste (data.CJB_approached.NP$ID, "_", data.CJB_approached.NP$run.order   )  )
                      names(data.CJB_approached.NP )    <- c("ID", "year", "sex",  "run.order", "order.NP", "prev.rewarded.NP", "latency.NP", "Latency_tr.NP","Latency_tr2.NP", "match")
                      data.CJB_approached.NP <- data.CJB_approached.NP [, c(1,5:10)]

data.CJB_approached.M <- subset (data.CJB_approached.pruned ,  data.CJB_approached.pruned$cue.type=="M" )  
                      data.CJB_approached.M <- data.CJB_approached.M [, c(1:4, 6:10)]
                      data.CJB_approached.M <- data.frame (data.CJB_approached.M , match = paste (data.CJB_approached.M$ID, "_", data.CJB_approached.M$run.order   )  )
                      names(data.CJB_approached.M )    <- c("ID", "year", "sex",  "run.order", "order.M", "prev.rewarded.M", "latency.M", "Latency_tr.M","Latency_tr2.M", "match")
                      data.CJB_approached.M <- data.CJB_approached.M [, c(1,5:10)]

data.CJB_approached.NN <- subset (data.CJB_approached.pruned ,  data.CJB_approached.pruned$cue.type=="NN" )  
                      data.CJB_approached.NN <- data.CJB_approached.NN [, c(1:4, 6:10)]
                      data.CJB_approached.NN <- data.frame (data.CJB_approached.NN , match = paste (data.CJB_approached.NN$ID, "_", data.CJB_approached.NN$run.order   )  )
                      names(data.CJB_approached.NN )    <- c("ID", "year", "sex",  "run.order", "order.NN", "prev.rewarded.NN", "latency.NN", "Latency_tr.NN","Latency_tr2.NN", "match")
                      data.CJB_approached.NN <- data.CJB_approached.NN [, c(1,5:10)]

data.CJB_approached.N <- subset (data.CJB_approached.pruned ,  data.CJB_approached.pruned$cue.type=="N" |data.CJB_approached.pruned$cue.type=="N " )  
                      data.CJB_approached.N <- data.CJB_approached.N [, c(1:4, 6:10)]
                      data.CJB_approached.N <- data.frame (data.CJB_approached.N , match = paste (data.CJB_approached.N$ID, "_", data.CJB_approached.N$run.order   )  )
                      names(data.CJB_approached.N )    <- c("ID", "year", "sex",  "run.order", "order.N", "prev.rewarded.N", "latency.N", "Latency_tr.N","Latency_tr2.N", "match")
                      data.CJB_approached.N <- data.CJB_approached.N [, c(1,5:10)]

                      
data.CJB_approached.multivar <- merge (data.common, data.CJB_approached.P , by=c("match","ID") , all.x=TRUE)
data.CJB_approached.multivar <- merge (data.CJB_approached.multivar, data.CJB_approached.NP ,by=c("match","ID")  , all.x=TRUE)
data.CJB_approached.multivar <- merge (data.CJB_approached.multivar, data.CJB_approached.M , by=c("match","ID") , all.x=TRUE)
data.CJB_approached.multivar <- merge (data.CJB_approached.multivar, data.CJB_approached.NN , by=c("match","ID")  , all.x=TRUE)
data.CJB_approached.multivar <- merge (data.CJB_approached.multivar, data.CJB_approached.N , by=c("match","ID") , all.x=TRUE)
data.CJB_approached.multivar   <- data.CJB_approached.multivar[order(data.CJB_approached.multivar$ID,data.CJB_approached.multivar$run.order ),]

Latency <-  data.frame(data.CJB_approached.multivar$latency.P ,data.CJB_approached.multivar$latency.NP, data.CJB_approached.multivar$latency.M, data.CJB_approached.multivar$latency.NN,data.CJB_approached.multivar$latency.N)
  Latency <- rowSums (Latency, na.rm=TRUE)
  data.CJB_approached.multivar$Latency <- Latency
  data.CJB_approached.multivar <- subset (data.CJB_approached.multivar, data.CJB_approached.multivar$Latency>0 )

 head(data.CJB_approached.multivar);  names(data.CJB_approached.multivar)
View(data.CJB_approached.multivar)    #   <-  CHECK DATA


# variables x models:
ID <-   data.CJB_approached.multivar$ID
F <- as.numeric(data.CJB_approached.multivar$sex=="F")
run.order <- data.CJB_approached.multivar$run.order

prev.rewarded.P<- data.CJB_approached.multivar$ prev.rewarded.P
first.P<- data.CJB_approached.multivar$order.P
Latency_tr.P  <- data.CJB_approached.multivar$Latency_tr.P 
Latency_tr2.P  <- data.CJB_approached.multivar$Latency_tr2.P 

prev.rewarded.NP<- data.CJB_approached.multivar$prev.rewarded.NP
first.NP<- data.CJB_approached.multivar$order.NP
Latency_tr.NP  <- data.CJB_approached.multivar$Latency_tr.NP 
Latency_tr2.NP  <- data.CJB_approached.multivar$Latency_tr2.NP 

prev.rewarded.M<- data.CJB_approached.multivar$ prev.rewarded.M
first.M<- data.CJB_approached.multivar$order.M
Latency_tr.M  <- data.CJB_approached.multivar$Latency_tr.M
Latency_tr2.M  <- data.CJB_approached.multivar$Latency_tr2.M

prev.rewarded.NN<- data.CJB_approached.multivar$ prev.rewarded.NN
first.NN<- data.CJB_approached.multivar$order.NN
Latency_tr.NN  <- data.CJB_approached.multivar$Latency_tr.NN
Latency_tr2.NN  <- data.CJB_approached.multivar$Latency_tr2.NN

prev.rewarded.N<- data.CJB_approached.multivar$ prev.rewarded.N
first.N<- data.CJB_approached.multivar$order.N
Latency_tr.N  <- data.CJB_approached.multivar$Latency_tr.N
Latency_tr2.N  <- data.CJB_approached.multivar$Latency_tr2.N

# centering:
prev.rewarded.P_C <- prev.rewarded.P -mean(prev.rewarded.P, na.rm=T)
prev.rewarded.N_C <- prev.rewarded.N -mean(prev.rewarded.N, na.rm=T)
prev.rewarded.NP_C <- prev.rewarded.NP -mean(prev.rewarded.NP, na.rm=T)
prev.rewarded.M_C <- prev.rewarded.M -mean(prev.rewarded.M, na.rm=T)
prev.rewarded.NN_C <- prev.rewarded.NN -mean(prev.rewarded.NN, na.rm=T)

first.P_C <- first.P - mean (first.P, na.rm=T)
first.NP_C <- first.NP - mean (first.NP, na.rm=T)
first.M_C <- first.M - mean (first.M, na.rm=T)
first.NN_C <- first.NN - mean (first.NN, na.rm=T)
first.N_C <- first.N - mean (first.N, na.rm=T)

F_C <- F-mean(F, na.rm=TRUE)
run.order_C  <- (run.order-mean(run.order, na.rm=T)) / (2*sd(run.order, na.rm=T)) 



data.CJB_approached.multivar <- data.frame (ID=as.factor(ID), F_C, run.order_C, 
                                                 prev.rewarded.P_C, first.P_C,Latency_tr.P ,Latency_tr2.P , 
                                            prev.rewarded.NP_C,first.NP_C, Latency_tr.NP , Latency_tr2.NP, 
                                            prev.rewarded.M_C, first.M_C,Latency_tr.M ,Latency_tr2.M ,
                                            prev.rewarded.NN_C, first.NN_C, Latency_tr.NN  , Latency_tr2.NN ,
                                                 prev.rewarded.N_C,first.N_C , Latency_tr2.N, Latency_tr.N )
        nrow(data.CJB_approached.multivar)
    data.CJB_approached.multivar <- merge (data.CJB_approached.multivar , data.MID, by="ID", all.y=FALSE)
        nrow(data.CJB_approached.multivar)
     View(data.CJB_approached.multivar)  #   <-  CHECK DATA



#___________
# MODELS:
#___________
     

#::::::::::::::::::::::::::::::::::####
# All 5  cues *   <======  ####
#::::::::::::::::::::::::::::::::::####

# checked NO SEX effect *
            
            
  #__________________________________________
  # Latency_tr <---------------
  #__________________________________________
        
            
              #..........................................................................              
                # run.order for Positiv & Negative,   "first"   for Ambiguous        
              #.......................................................................... 
                        
              model.CJB.5cues.Lat.multiv_1 <-   asreml(cbind(Latency_tr.P, Latency_tr.NP, Latency_tr.M , Latency_tr.NN, Latency_tr.N )  ~ trait  
                                                       + at(trait, 1):run.order_C +  at(trait, 5):run.order_C +   
                                                         at(trait, 2):first.NP_C+ at(trait, 3):first.M_C+  at(trait, 4):first.NN_C  
                                                       +at(trait, 1):prev.rewarded.P_C +  at(trait, 2):prev.rewarded.NP_C+   at(trait, 3):prev.rewarded.M_C+ + at(trait, 4):prev.rewarded.NN_C + at(trait, 5):prev.rewarded.N_C
                                                       ,random= ~ ID:idv(trait),  rcov= ~ units:idh(trait), data=data.CJB_approached.multivar, maxiter = 200, na.method.X = "include")   # 
              
              
              model.CJB.5cues.Lat.multiv_2 <-  asreml(cbind(Latency_tr.P, Latency_tr.NP, Latency_tr.M , Latency_tr.NN, Latency_tr.N )  ~   trait 
                                                      + at(trait, 1):run.order_C +  at(trait, 5):run.order_C 
                                                      +   at(trait, 2):first.NP_C+ at(trait, 3):first.M_C+  at(trait, 4):first.NN_C 
                                                      +at(trait, 1):prev.rewarded.P_C +  at(trait, 2):prev.rewarded.NP_C+   at(trait, 3):prev.rewarded.M_C+ + at(trait, 4):prev.rewarded.NN_C + at(trait, 5):prev.rewarded.N_C
                                                      ,random= ~ ID:idh(trait),  rcov= ~ units:idh(trait), data=data.CJB_approached.multivar, maxiter = 200, na.method.X = "include") 
              
              model.CJB.5cues.Lat.multiv_3 <-  asreml(cbind(Latency_tr.P, Latency_tr.NP, Latency_tr.M , Latency_tr.NN, Latency_tr.N ) ~  trait  
                                                      + at(trait, 1):run.order_C +  at(trait, 5):run.order_C 
                                                      +   at(trait, 2):first.NP_C+ at(trait, 3):first.M_C+  at(trait, 4):first.NN_C  
                                                      +at(trait, 1):prev.rewarded.P_C +  at(trait, 2):prev.rewarded.NP_C+   at(trait, 3):prev.rewarded.M_C+ + at(trait, 4):prev.rewarded.NN_C + at(trait, 5):prev.rewarded.N_C
                                                      ,random= ~ ID:us(trait),  rcov= ~ units:idh(trait), data=data.CJB_approached.multivar, maxiter = 1000, na.method.X = "include") 
              #
              
              summary(model.CJB.5cues.Lat.multiv_3 , all=TRUE)$coef.fixed ; summary(model.CJB.5cues.Lat.multiv_3 , all=TRUE)$varcomp
              # fixed effects: latency decrease with run order for positive cues, but increase for negatives;  no sign effect (first_C) on ambiguous, but clsoe to sign for M and NN
              # previous reward decrease latency for all cue types (espcially for positive)
              
              
              
              
              animalmodel.CJB.5cues.Lat.multiv_1a <-   asreml(cbind(Latency_tr.P, Latency_tr.NP, Latency_tr.M , Latency_tr.NN, Latency_tr.N )  ~   trait  
                                                              + at(trait, 1):run.order_C +  at(trait, 5):run.order_C 
                                                              +   at(trait, 2):first.NP_C+ at(trait, 3):first.M_C+  at(trait, 4):first.NN_C  
                                                              +at(trait, 1):prev.rewarded.P_C +  at(trait, 2):prev.rewarded.NP_C+   at(trait, 3):prev.rewarded.M_C+ + at(trait, 4):prev.rewarded.NN_C + at(trait, 5):prev.rewarded.N_C
                                                              , random =~  ped (ID, var=T):idv(trait) +ide (ID, var=T):idv(trait) , ginverse=list(ID=ainv) ,rcov= ~ units:idh(trait), data=data.CJB_approached.multivar, maxiter = 200, na.method.X = "include")   # 
              
              
              animalmodel.CJB.5cues.Lat.multiv_1b <-   asreml(cbind(Latency_tr.P, Latency_tr.NP, Latency_tr.M , Latency_tr.NN, Latency_tr.N )  ~  trait  
                                                              + at(trait, 1):run.order_C +  at(trait, 5):run.order_C 
                                                              +   at(trait, 2):first.NP_C+ at(trait, 3):first.M_C+  at(trait, 4):first.NN_C  
                                                              +at(trait, 1):prev.rewarded.P_C +  at(trait, 2):prev.rewarded.NP_C+   at(trait, 3):prev.rewarded.M_C+ + at(trait, 4):prev.rewarded.NN_C + at(trait, 5):prev.rewarded.N_C
                                                              , random =~  ped (ID, var=T):idh(trait) +ide (ID, var=T):idh(trait) ,  ginverse=list(ID=ainv) ,rcov= ~ units:idh(trait), data=data.CJB_approached.multivar, maxiter = 200, na.method.X = "include")   # 
              
              
              animalmodel.CJB.5cues.Lat.multiv_1c <-   asreml(cbind(Latency_tr.P, Latency_tr.NP, Latency_tr.M , Latency_tr.NN, Latency_tr.N )  ~  trait 
                                                              + at(trait, 1):run.order_C +  at(trait, 5):run.order_C 
                                                              +   at(trait, 2):first.NP_C+ at(trait, 3):first.M_C+  at(trait, 4):first.NN_C  
                                                              +at(trait, 1):prev.rewarded.P_C +  at(trait, 2):prev.rewarded.NP_C+   at(trait, 3):prev.rewarded.M_C+ + at(trait, 4):prev.rewarded.NN_C + at(trait, 5):prev.rewarded.N_C
                                                              , random =~  ped (ID, var=T):us(trait) +ide (ID, var=T):us(trait)  ,  ginverse=list(ID=ainv) ,rcov= ~ units:idh(trait), data=data.CJB_approached.multivar, maxiter = 1000, na.method.X = "include")   # 
              # did not converge
              
              summary(animalmodel.CJB.5cues.Lat.multiv_1a)  ;  summary(animalmodel.CJB.5cues.Lat.multiv_1b) ; summary(animalmodel.CJB.5cues.Lat.multiv_1c)
              
              
  
#..........................................................................              
# run.order for all       
#.......................................................................... 

  model.CJB.5cues.Lat.multiv_1 <-   asreml(cbind(Latency_tr.P, Latency_tr.NP, Latency_tr.M , Latency_tr.NN, Latency_tr.N )  ~ trait  
                                           + trait:run.order_C +     
                                             +at(trait, 1):prev.rewarded.P_C +  at(trait, 2):prev.rewarded.NP_C+   at(trait, 3):prev.rewarded.M_C+ + at(trait, 4):prev.rewarded.NN_C + at(trait, 5):prev.rewarded.N_C
                                           ,random= ~ ID:idv(trait),  rcov= ~ units:idh(trait), data=data.CJB_approached.multivar, maxiter = 200, na.method.X = "include")   # 
  
  
  model.CJB.5cues.Lat.multiv_2 <-  asreml(cbind(Latency_tr.P, Latency_tr.NP, Latency_tr.M , Latency_tr.NN, Latency_tr.N )  ~   trait 
                                          + trait:run.order_C +     
                                            +at(trait, 1):prev.rewarded.P_C +  at(trait, 2):prev.rewarded.NP_C+   at(trait, 3):prev.rewarded.M_C+ + at(trait, 4):prev.rewarded.NN_C + at(trait, 5):prev.rewarded.N_C
                                          ,random= ~ ID:idh(trait),  rcov= ~ units:idh(trait), data=data.CJB_approached.multivar, maxiter = 200, na.method.X = "include") 
  
  model.CJB.5cues.Lat.multiv_3 <-  asreml(cbind(Latency_tr.P, Latency_tr.NP, Latency_tr.M , Latency_tr.NN, Latency_tr.N ) ~  trait  
                                          + trait:run.order_C +     
                                            +at(trait, 1):prev.rewarded.P_C +  at(trait, 2):prev.rewarded.NP_C+   at(trait, 3):prev.rewarded.M_C+ + at(trait, 4):prev.rewarded.NN_C + at(trait, 5):prev.rewarded.N_C
                                          ,random= ~ ID:us(trait),  rcov= ~ units:idh(trait), data=data.CJB_approached.multivar, maxiter = 1000, na.method.X = "include") 
  #
  
  summary(model.CJB.5cues.Lat.multiv_3 , all=TRUE)$coef.fixed 
  # fixed effects: latency decrease with run order for positive cues, but increase for negatives;   sign effect on Middle ambiguous
  # previous reward decrease latency for positive and negative cues
  
  summary(model.CJB.5cues.Lat.multiv_1 , all=TRUE)$varcomp
  summary(model.CJB.5cues.Lat.multiv_2 , all=TRUE)$varcomp
  summary(model.CJB.5cues.Lat.multiv_3 , all=TRUE)$varcomp
  
  
  
  info.crit.asreml (      model.CJB.5cues.Lat.multiv_1) # AIC= -2486
  info.crit.asreml (     model.CJB.5cues.Lat.multiv_2) # AIC= -2491
  info.crit.asreml (     model.CJB.5cues.Lat.multiv_3) # AIC= -2843 *
  
  
  
  
  # Repetabilities 

  # model b (without correlations)
  nadiv:::pin(  model.CJB.5cues.Lat.multiv_2, R~ V1/(V1+V7) )  # Rpo = 0.40+-0.03
  nadiv:::pin(  model.CJB.5cues.Lat.multiv_2, R~ V2/(V2+V8) )  # Rnp = 0.27 +-0.05
  nadiv:::pin(   model.CJB.5cues.Lat.multiv_2, R~ V3/(V3+V9 ) )  # Rm =  0.36 +-0.05
  nadiv:::pin(  model.CJB.5cues.Lat.multiv_2, R~ V4/(V4+ V10 ) )  # Rnn = 0.33+-0.07
  nadiv:::pin(  model.CJB.5cues.Lat.multiv_2, R~ V5/(V5+ V11 ) )  # Rne = 0.22 +-0.03
  
  # model c (with correlations bw cues) ***
  nadiv:::pin(  model.CJB.5cues.Lat.multiv_3, R~ V1/(V1+V17) )  # Rpo = 0.41+-0.03
  nadiv:::pin(  model.CJB.5cues.Lat.multiv_3, R~ V3/(V3+V18) )  # Rnp = 0.37+-0.05
  nadiv:::pin(   model.CJB.5cues.Lat.multiv_3, R~ V6/(V6+V19 ) )  # Rm = 0.41+-0.05
  nadiv:::pin(  model.CJB.5cues.Lat.multiv_3, R~ V10/(V10+ V20 ) )  # Rnn = 0.37+-0.07
  nadiv:::pin(  model.CJB.5cues.Lat.multiv_3, R~ V15/(V15+ V21 ) )  # Rne = 0.24+-0.03
  
  # r bw cues
  nadiv:::pin(   model.CJB.5cues.Lat.multiv_3, r~ V2  /sqrt(V1*V3) )  # r po-np = 0.97  +- 0.05
  nadiv:::pin(  model.CJB.5cues.Lat.multiv_3, r~ V5  /sqrt(V3 *V6 ) )  # r np-m = 0.80 +-0.08
  nadiv:::pin(   model.CJB.5cues.Lat.multiv_3 , r~ V9 /sqrt(V10 *V6 ) )  # r m-nn = 0.80 +-0.11
  nadiv:::pin(   model.CJB.5cues.Lat.multiv_3, r~ V14  /sqrt(V10 *V15 ) )  # r nn-n = 0.74 +-0.10
  nadiv:::pin(   model.CJB.5cues.Lat.multiv_3 , r~ V4  /sqrt(V1 *V6) )  # r po-m = 0.87 +-0.05
  nadiv:::pin(  model.CJB.5cues.Lat.multiv_3 , r~ V7  /sqrt(V1 *V10) )  # r po-nn = 0.65 +-0.09
  nadiv:::pin(   model.CJB.5cues.Lat.multiv_3, r~ V11 /sqrt(V1 *V15) )  # r po-n =  0.54 +-0.08
  nadiv:::pin(  model.CJB.5cues.Lat.multiv_3 , r~ V8  /sqrt(V3 *V10) )  # r np-nn = 0.48 +-0.12
  nadiv:::pin(  model.CJB.5cues.Lat.multiv_3, r~ V12  /sqrt(V15 *V3) )  # r np-n = 0.48 +-0.10
  nadiv:::pin(   model.CJB.5cues.Lat.multiv_3 , r~  V13  /sqrt(V15 *V6) )  # r m-n = 0.71 +-0.09
  
  
  
  
  
 #//////////
  # G 
 #//////////
  
  animalmodel.CJB.5cues.Lat.multiv_1a <-   asreml(cbind(Latency_tr.P, Latency_tr.NP, Latency_tr.M , Latency_tr.NN, Latency_tr.N )  ~   trait  
                                                  + trait:run.order_C  
                                                  +at(trait, 1):prev.rewarded.P_C +  at(trait, 2):prev.rewarded.NP_C+   at(trait, 3):prev.rewarded.M_C+ + at(trait, 4):prev.rewarded.NN_C + at(trait, 5):prev.rewarded.N_C
                                                  , random =~  ped (ID, var=T):idv(trait) +ide (ID, var=T):idv(trait) , ginverse=list(ID=ainv) ,rcov= ~ units:idh(trait), data=data.CJB_approached.multivar, maxiter = 200, na.method.X = "include")   # 
  
  
  animalmodel.CJB.5cues.Lat.multiv_1b <-   asreml(cbind(Latency_tr.P, Latency_tr.NP, Latency_tr.M , Latency_tr.NN, Latency_tr.N )  ~  trait  
                                                  + trait:run.order_C  
                                                  +at(trait, 1):prev.rewarded.P_C +  at(trait, 2):prev.rewarded.NP_C+   at(trait, 3):prev.rewarded.M_C+ + at(trait, 4):prev.rewarded.NN_C + at(trait, 5):prev.rewarded.N_C
                                                  , random =~  ped (ID, var=T):idh(trait) +ide (ID, var=T):idh(trait) ,  ginverse=list(ID=ainv) ,rcov= ~ units:idh(trait), data=data.CJB_approached.multivar, maxiter = 200, na.method.X = "include")   # 
  
  
  animalmodel.CJB.5cues.Lat.multiv_1c <-   asreml(cbind(Latency_tr.P, Latency_tr.NP, Latency_tr.M , Latency_tr.NN, Latency_tr.N )  ~  trait 
                                                  + trait:run.order_C  
                                                  +at(trait, 1):prev.rewarded.P_C +  at(trait, 2):prev.rewarded.NP_C+   at(trait, 3):prev.rewarded.M_C+ + at(trait, 4):prev.rewarded.NN_C + at(trait, 5):prev.rewarded.N_C
                                                  , random =~  ped (ID, var=T):us(trait) +ide (ID, var=T):us(trait)  ,  ginverse=list(ID=ainv) ,rcov= ~ units:idh(trait), data=data.CJB_approached.multivar, maxiter = 2000, na.method.X = "include")   # 
  #
  
  summary(animalmodel.CJB.5cues.Lat.multiv_1a)  
  summary(animalmodel.CJB.5cues.Lat.multiv_1b) 
  summary(animalmodel.CJB.5cues.Lat.multiv_1c)
  
  
  info.crit.asreml (    animalmodel.CJB.5cues.Lat.multiv_1a) # AIC= -2489
  info.crit.asreml (    animalmodel.CJB.5cues.Lat.multiv_1b) # AIC= -2489
  info.crit.asreml (   animalmodel.CJB.5cues.Lat.multiv_1c) # AIC=    -2819 **                  
  
  #________________________________ 
  
  # h2
  
  
  #   on latent scale
  
  # model a   
  
  
  # model b (without correlations)
  
  nadiv:::pin(  animalmodel.CJB.5cues.Lat.multiv_1b, h2~ V1 /(V1 +V6 +V12) )  # h2po =   0.03+-0.05
  nadiv:::pin(   animalmodel.CJB.5cues.Lat.multiv_1b , e2~ V6 /(V1 +V6 +V12) )  # e2po =  0.37 +-0.05 *
  
  nadiv:::pin(   animalmodel.CJB.5cues.Lat.multiv_1b , h2~ V2 /(V2 +V7 +V13) )  # h2np =   0.03+-0.06
  nadiv:::pin(   animalmodel.CJB.5cues.Lat.multiv_1b , e2~ V7 /(V2 +V7 +V13) )  # e2np =  0.24+-0.08 *
  
  nadiv:::pin(  animalmodel.CJB.5cues.Lat.multiv_1b , h2~ V3 /(V3 +V8 +V14) )  # h2m =    0.11 +-0.08
  nadiv:::pin(   animalmodel.CJB.5cues.Lat.multiv_1b , e2~ V8 /(V3 +V8 +V14) )  # e2m =    0.25 +- 0.09 *
  
  nadiv:::pin(   animalmodel.CJB.5cues.Lat.multiv_1b , h2~ V4 /(V4 +V9 +V15) )  # h2nn = 0 +- 0  
  nadiv:::pin(  animalmodel.CJB.5cues.Lat.multiv_1b , e2~ V9 /(V4 +V9 +V15) )  # e2nn =   0.33 +-0.07 * 
  
  nadiv:::pin(   animalmodel.CJB.5cues.Lat.multiv_1b , h2~ V5 /(V5 +V10 +V16) )  # h2ne =   0.10+-0.06
  nadiv:::pin(  animalmodel.CJB.5cues.Lat.multiv_1b , e2~ V10 /(V5 +V10 +V16) )  # e2ne =    0.13 +-0.06 *
  
  
  # model c (with correlations bw cues)
  .....
  
  
  
  
  
  
#_________________________________________________________________________________________________________________________________________________
  
            
#::::::::::::::::::::::::::::::::::::::::::::::::.:::::::####
  #  only AMBIGUOUS cues ***  <======  ####
#:::::::::::::::::::::::::::::::::::::::::::::::::::::::####  
            
       
            
  # Latency_tr
  
                                
                  #.........................           
                  #  "first"         
                  #.........................
                                
                model.CJB.3cues.Lat.multiv_1 <-   asreml(cbind( Latency_tr.NP, Latency_tr.M, Latency_tr.NN )  ~ trait  
                                                         + at(trait, 1):first.NP_C+ at(trait, 2):first.M_C+  at(trait, 3):first.NN_C  
                                                         +at(trait, 1):prev.rewarded.NP_C+   at(trait,2):prev.rewarded.M_C+ + at(trait,3):prev.rewarded.NN_C 
                                                         ,random= ~ ID:idv(trait),  rcov= ~ units:idh(trait), data=data.CJB_approached.multivar, maxiter = 200, na.method.X = "include")   # 
                
                
                model.CJB.3cues.Lat.multiv_2 <-  asreml(cbind( Latency_tr.NP, Latency_tr.M, Latency_tr.NN )  ~   trait 
                                                        + at(trait, 1):first.NP_C+ at(trait, 2):first.M_C+  at(trait, 3):first.NN_C  
                                                        + at(trait, 1):prev.rewarded.NP_C+   at(trait,2):prev.rewarded.M_C+ + at(trait,3):prev.rewarded.NN_C 
                                                        ,random= ~ ID:idh(trait),  rcov= ~ units:idh(trait), data=data.CJB_approached.multivar, maxiter = 200, na.method.X = "include") 
                
                model.CJB.3cues.Lat.multiv_3 <-  asreml(cbind( Latency_tr.NP, Latency_tr.M, Latency_tr.NN ) ~  trait  
                                                        + at(trait, 1):first.NP_C+ at(trait, 2):first.M_C+  at(trait, 3):first.NN_C  
                                                        +  at(trait, 1):prev.rewarded.NP_C+   at(trait,2):prev.rewarded.M_C+ + at(trait,3):prev.rewarded.NN_C 
                                                        ,random= ~ ID:us(trait),  rcov= ~ units:idh(trait), data=data.CJB_approached.multivar, maxiter = 1000, na.method.X = "include") 
                #
                
                summary(model.CJB.3cues.Lat.multiv_3 , all=TRUE)$coef.fixed 
                summary(model.CJB.3cues.Lat.multiv_3 , all=TRUE)$varcomp
                # fixed effects:  no sign effect (first_C) on any ambiguous 
                # previous reward decrease latency (but sign ony for NP)
              #_________________________________________________________________________  
  
  #.........................           
  #  run order     
  #.........................
  
  model.CJB.3cues.Lat.multiv_1 <-   asreml(cbind( Latency_tr.NP, Latency_tr.M, Latency_tr.NN )  ~ trait  
                                           + trait:run.order_C
                                           +at(trait, 1):prev.rewarded.NP_C+   at(trait,2):prev.rewarded.M_C+ + at(trait,3):prev.rewarded.NN_C 
                                           ,random= ~ ID:idv(trait),  rcov= ~ units:idh(trait), data=data.CJB_approached.multivar, maxiter = 200, na.method.X = "include")   # 
  
  
  model.CJB.3cues.Lat.multiv_2 <-  asreml(cbind( Latency_tr.NP, Latency_tr.M, Latency_tr.NN )  ~   trait 
                                          + trait:run.order_C  
                                          + at(trait, 1):prev.rewarded.NP_C+   at(trait,2):prev.rewarded.M_C+ + at(trait,3):prev.rewarded.NN_C 
                                          ,random= ~ ID:idh(trait),  rcov= ~ units:idh(trait), data=data.CJB_approached.multivar, maxiter = 200, na.method.X = "include") 
  
  model.CJB.3cues.Lat.multiv_3 <-  asreml(cbind( Latency_tr.NP, Latency_tr.M, Latency_tr.NN ) ~  trait  
                                          + trait:run.order_C
                                          +  at(trait, 1):prev.rewarded.NP_C+   at(trait,2):prev.rewarded.M_C+ + at(trait,3):prev.rewarded.NN_C 
                                          ,random= ~ ID:us(trait),  rcov= ~ units:idh(trait), data=data.CJB_approached.multivar, maxiter = 1000, na.method.X = "include") 
  #
  
  summary(model.CJB.3cues.Lat.multiv_3 , all=TRUE)$coef.fixed 
  #fixed effects:  sign effect run order on MID ambiguous -> increase Lat 
  # previous reward decrease latency (but just sign only for NP)  
  
  summary(model.CJB.3cues.Lat.multiv_1 , all=TRUE)$varcomp
  summary(model.CJB.3cues.Lat.multiv_2 , all=TRUE)$varcomp
  summary(model.CJB.3cues.Lat.multiv_3 , all=TRUE)$varcomp
  
  
  
  info.crit.asreml (    model.CJB.3cues.Lat.multiv_1) # AIC= -502
  info.crit.asreml (     model.CJB.3cues.Lat.multiv_2) # AIC= -507
  info.crit.asreml (    model.CJB.3cues.Lat.multiv_3) # AIC=  -591  *
  
  
  
  
  # Repetabilities 
  
  
  # model b (without correlations)
  nadiv:::pin(    model.CJB.3cues.Lat.multiv_2, R~ V1 /(V1 +V5 ) )  # Rnp = 0.27 +-0.05
  nadiv:::pin(     model.CJB.3cues.Lat.multiv_2, R~ V2 /(V2 +V6  ) )  # Rm =  0.36 +-0.05
  nadiv:::pin(    model.CJB.3cues.Lat.multiv_2, R~ V3 /(V3 + V7  ) )  # Rnn = 0.33+-0.07
  
  
  # model c (with correlations bw cues) ***
  nadiv:::pin(  model.CJB.3cues.Lat.multiv_3, R~ V1/(V1+V8) )  # Rnp = 0.28 +-0.05
  nadiv:::pin(  model.CJB.3cues.Lat.multiv_3, R~ V3/(V3+V9 ) )  # Rm = 0.38+-0.05
  nadiv:::pin(  model.CJB.3cues.Lat.multiv_3, R~ V6/(V6+ V10 ) )  # Rnn = 0.35+-0.07
  
  
  # r bw cues
  nadiv:::pin(   model.CJB.3cues.Lat.multiv_3, r~ V2  /sqrt(V1 *V3 ) )  # r np-m = 0.85 +-0.10
  nadiv:::pin(   model.CJB.3cues.Lat.multiv_3 , r~ V5 /sqrt(V3 *V6 ) )  # r m-nn = 0.83 +-0.12
        nadiv:::pin(   model.CJB.3cues.Lat.multiv_3 , r~ V4  /sqrt(V1 *V6) )  # r np-nn = 0.43 +-0.14
  
  
  
  
  
  
  
  
  #////////
  # G
  #//////////
  
  animalmodel.CJB.3cues.Lat.multiv_1 <-   asreml(cbind( Latency_tr.NP, Latency_tr.M, Latency_tr.NN )  ~   trait  
                                                 + trait:run.order_C   
                                                 + at(trait, 1):prev.rewarded.NP_C+   at(trait,2):prev.rewarded.M_C+ + at(trait,3):prev.rewarded.NN_C 
                                                 , random =~  ped (ID, var=T) +ide (ID, var=T) , ginverse=list(ID=ainv) ,rcov= ~ units:idh(trait), data=data.CJB_approached.multivar, maxiter = 200, na.method.X = "include")   # 
  
  
  
  animalmodel.CJB.3cues.Lat.multiv_1a <-   asreml(cbind( Latency_tr.NP, Latency_tr.M, Latency_tr.NN )  ~   trait  
                                                  + trait:run.order_C   
                                                  + at(trait, 1):prev.rewarded.NP_C+   at(trait,2):prev.rewarded.M_C+ + at(trait,3):prev.rewarded.NN_C 
                                                  , random =~  ped (ID, var=T):idv(trait) +ide (ID, var=T):idv(trait) , ginverse=list(ID=ainv) ,rcov= ~ units:idh(trait), data=data.CJB_approached.multivar, maxiter = 200, na.method.X = "include")   # 
  
  
  animalmodel.CJB.3cues.Lat.multiv_1b <-   asreml(cbind( Latency_tr.NP, Latency_tr.M, Latency_tr.NN )  ~  trait  
                                                  + trait:run.order_C  
                                                  + at(trait, 1):prev.rewarded.NP_C+   at(trait,2):prev.rewarded.M_C+ + at(trait,3):prev.rewarded.NN_C 
                                                  , random =~  ped (ID, var=T):idh(trait) +ide (ID, var=T):idh(trait) ,  ginverse=list(ID=ainv) ,rcov= ~ units:idh(trait), data=data.CJB_approached.multivar, maxiter = 200, na.method.X = "include")   # 
  
  
  animalmodel.CJB.3cues.Lat.multiv_1c <-   asreml(cbind( Latency_tr.NP, Latency_tr.M, Latency_tr.NN )  ~  trait 
                                                  + trait:run.order_C  
                                                  + at(trait, 1):prev.rewarded.NP_C+   at(trait,2):prev.rewarded.M_C+ + at(trait,3):prev.rewarded.NN_C 
                                                  , random =~  ped (ID, var=T):us(trait) +ide (ID, var=T):us(trait)  ,  ginverse=list(ID=ainv) ,rcov= ~ units:idh(trait), data=data.CJB_approached.multivar, maxiter = 2000, na.method.X = "include")   # 
  # 
  summary(animalmodel.CJB.3cues.Lat.multiv_1)  
    summary(animalmodel.CJB.3cues.Lat.multiv_1a)  
    summary(animalmodel.CJB.3cues.Lat.multiv_1b) 
    summary(animalmodel.CJB.3cues.Lat.multiv_1c) #*
    
    
    info.crit.asreml (   animalmodel.CJB.3cues.Lat.multiv_1a) # AIC=  -503
    info.crit.asreml (    animalmodel.CJB.3cues.Lat.multiv_1b) # AIC=   -505              
    info.crit.asreml (    animalmodel.CJB.3cues.Lat.multiv_1c) # AIC=  -580*
    
    #________________________________ 
    
    # h2
    
  
    # model b (without correlations)
    nadiv:::pin(   animalmodel.CJB.3cues.Lat.multiv_1b , h2~ V1 /(V1 +V4 +V8 ) )  # h2np =  0.03+-0.06 
    nadiv:::pin(   animalmodel.CJB.3cues.Lat.multiv_1b , e2~ V4 /(V1 +V4 +V8 ) )  # e2np =  0.24 +-0.08 *
    
    nadiv:::pin(  animalmodel.CJB.3cues.Lat.multiv_1b , h2~ V2 /(V2 +V5 +V9 ) )  # h2m =  0.11 +-0.08  
    nadiv:::pin(   animalmodel.CJB.3cues.Lat.multiv_1b , e2~ V5 /(V2 +V5 +V9 ) )  # e2m =   0.25 +-0.09 *  
    
    nadiv:::pin(   animalmodel.CJB.3cues.Lat.multiv_1b , h2~ V3 /(V3 +V6 +V10 ) )  # h2nn = 0 +- 0
    nadiv:::pin(  animalmodel.CJB.3cues.Lat.multiv_1b , e2~ V6 /(V3 +V6 +V10 ) )  # e2nn =  0.33 +-0.07 
    
    
    
    
    # model c (with correlations bw cues)
    
    nadiv:::pin(    animalmodel.CJB.3cues.Lat.multiv_1c , h2~ V1/( V1+V7+V14) )  # h2 NP = 0.09 +- 0.09
    nadiv:::pin(    animalmodel.CJB.3cues.Lat.multiv_1c , h2~ V3/(V3+V9+V15) )  # h2 M =  0.12 +- 0.08
    nadiv:::pin(    animalmodel.CJB.3cues.Lat.multiv_1c , h2~ V6/(V6+V12+V16) )  # h2 NN =  0.09 +- 0.11
  
    nadiv:::pin(    animalmodel.CJB.3cues.Lat.multiv_1c , e2~ V7/(V1+V7+V14) )  # e2 NP =  0.19 +- 0.08
    nadiv:::pin(    animalmodel.CJB.3cues.Lat.multiv_1c , e2~ V9/(V3+V9+V15) )  # e2 M =    0.29 +- 0.09
    nadiv:::pin(    animalmodel.CJB.3cues.Lat.multiv_1c , e2~ V12/(V6+V12+V16) )  # e2 NN =   0.26 +- 0.12

    
    
    
    
#__________________________________________________________________________________________________________________________

