
library(asreml)
library(nadiv)




#____________________________________
#  DISCRIMINANT LEARNING
#____________________________________


data.CJB_discr.learning  <-read.table('C:/Dropbox/Linkoping/_Data/data.models_CJB.ambiguous vs AssLearning_2014-2017.csv', header=T, sep=',', dec='.')  #
head(data.CJB_discr.learning )
View(data.CJB_discr.learning )




ID <-  as.factor(data.CJB_discr.learning$ID)

white  <- as.numeric ( data.CJB_discr.learning$trainedcolorAss=="White")
white_C <- ( white -mean (white, na.rm=T) )

N.runs.discr_tr   <- data.CJB_discr.learning$NrunsAsstr



  cuetype     <-data.CJB_discr.learning$cuetype
 M_C   <-data.CJB_discr.learning$MC
NN_C  <-data.CJB_discr.learning$NNC
run.order_C <-data.CJB_discr.learning$runorderC
       first_C <-data.CJB_discr.learning$firstC
prev.rewarded_C   <-data.CJB_discr.learning$prevrewardedC    

Latency_tr <- data.CJB_discr.learning$Latencytr1     
Approached <-data.CJB_discr.learning$Approached


data.CJB_discr.learning.biv <- data.frame (ID, white_C, N.runs.discr_tr,      M_C, NN_C, run.order_C, prev.rewarded_C, Latency_tr, Approached) 


#___________________________________________________________________________________________
# Models P APPROACH

init_cor <- c(0.1, 1,1);   names(init_cor) <- c("U","P" ,"P" )
init_res <- c(0,  1,   0.0000001);   names(init_res) <- c("F", "P", "F" )   


model.CJBAPPROACH_Discrlearning_1 <-   asreml(cbind(Approached, N.runs.discr_tr)  ~  trait 
                                             +  at(trait,2):white_C  
                                             +  at(trait,1):M_C + at(trait,1):NN_C
                                             +  at(trait, 1):prev.rewarded_C
                                             +  at(trait, 1):M_C:prev.rewarded_C +  at(trait, 1):NN_C:prev.rewarded_C
                                             
                                             ,random= ~ ID:corgh(trait, init=init_cor),  rcov= ~ units:corgh(trait, init= init_res), data=data.CJB_discr.learning.biv, maxiter = 100, na.method.X = "include")   # 


summary(model.CJBAPPROACH_Discrlearning_1, all=TRUE)$coef.fixed
summary(model.CJBAPPROACH_Discrlearning_1, all=TRUE)$varcomp


model.CJBAPPROACH_Discrlearning_2 <-   asreml(cbind(Approached, N.runs.discr_tr)  ~  trait 
                                             +  at(trait,2):white_C  
                                             +  at(trait,1):M_C + at(trait,1):NN_C
                                             
                                             +  at(trait, 1):prev.rewarded_C
                                             
                                             ,random= ~ ID:corgh(trait, init=init_cor),  rcov= ~ units:corgh(trait, init= init_res), data=data.CJB_discr.learning.biv, maxiter = 100, na.method.X = "include")   # 



summary(model.CJBAPPROACH_Discrlearning_2, all=TRUE)$coef.fixed
summary(model.CJBAPPROACH_Discrlearning_2, all=TRUE)$varcomp


nadiv:::pin( model.CJBAPPROACH_Discrlearning_2 , r~ V1 ) 



init_cor <- c(0.1, 1,1);   names(init_cor) <- c("U","P" ,"P" )
init_res <- c(0,  1,   0.0000001);   names(init_res) <- c("F", "P", "F" )   


model.CJBAPPROACH_Discrlearning_cor <-   asreml(cbind(Approached, N.runs.discr_tr)  ~  trait 
                                                +  at(trait,2):white_C  
                                                +  at(trait,1):M_C + at(trait,1):NN_C
                                                
                                                +  at(trait, 1):prev.rewarded_C
                                                
                                                ,random= ~ ID:corgh(trait, init=init_cor),  rcov= ~ units:corgh(trait, init= init_res), data=data.CJB_discr.learning.biv, maxiter = 100, na.method.X = "include")   # 




init_cor <- c(0, 1,1);   names(init_cor) <- c("F","P" ,"P" )
init_res <- c(0,  1,   0.0000001);   names(init_res) <- c("F", "P", "F" )   


model.CJBAPPROACH_Discrlearning_cor0 <-   asreml(cbind(Approached, N.runs.discr_tr)  ~  trait 
                                                 +  at(trait,2):white_C  
                                                 +  at(trait,1):M_C + at(trait,1):NN_C
                                                 
                                                 +  at(trait, 1):prev.rewarded_C
                                                 
                                                 ,random= ~ ID:corgh(trait, init=init_cor),  rcov= ~ units:corgh(trait, init= init_res), data=data.CJB_discr.learning.biv, maxiter = 100, na.method.X = "include")   # 


reml.lrt.asreml (   model.CJBAPPROACH_Discrlearning_cor ,model.CJBAPPROACH_Discrlearning_cor0  ) # P=0.80




#__________________________________________________________________________

# Models  LATENCY APPROACH


summary(model.CJB.3cues.asreml.univ_1);  summary(model.CJB.3cues.asreml.univ_1, all=TRUE)$coef.fixed;  summary(model.CJB.3cues.asreml.univ_1, all=TRUE)$varcomp  #   <-  Compare ***


init_cor <- c(0.1, 1,1);   names(init_cor) <- c("U","P" ,"P" )
init_res <- c(0,  1,   0.0000001);   names(init_res) <- c("F", "P", "F" )   
      
            
      model.CJBLat_Discrlearning_1 <-   asreml(cbind(Latency_tr, N.runs.discr_tr)  ~  trait 
                                               +  at(trait,2):white_C  
                                               +  at(trait,1):M_C + at(trait,1):NN_C
                                               +  at(trait, 1):prev.rewarded_C
                                               +  at(trait, 1):M_C:prev.rewarded_C +  at(trait, 1):NN_C:prev.rewarded_C
                                               
                                               ,random= ~ ID:corgh(trait, init=init_cor),  rcov= ~ units:corgh(trait, init= init_res), data=data.CJB_discr.learning.biv, maxiter = 100, na.method.X = "include")   # 
      
      
      summary(model.CJBLat_Discrlearning_1, all=TRUE)$coef.fixed
      summary(model.CJBLat_Discrlearning_1, all=TRUE)$varcomp

            
model.CJBLat_Discrlearning_2 <-   asreml(cbind(Latency_tr, N.runs.discr_tr)  ~  trait 
                                         +  at(trait,2):white_C  
                                         +  at(trait,1):M_C + at(trait,1):NN_C

                                         +  at(trait, 1):prev.rewarded_C
                                         
                                         ,random= ~ ID:corgh(trait, init=init_cor),  rcov= ~ units:corgh(trait, init= init_res), data=data.CJB_discr.learning.biv, maxiter = 100, na.method.X = "include")   # 



summary(model.CJBLat_Discrlearning_2, all=TRUE)$coef.fixed
summary(model.CJBLat_Discrlearning_2, all=TRUE)$varcomp



nadiv:::pin( model.CJBLat_Discrlearning_2 , r~ V1 ) 

init_cor <- c(0.1, 1,1);   names(init_cor) <- c("U","P" ,"P" )
init_res <- c(0,  1,   0.0000001);   names(init_res) <- c("F", "P", "F" )   


model.CJBLat_Discrlearning_cor <-   asreml(cbind(Latency_tr, N.runs.discr_tr)  ~  trait 
                                           +  at(trait,2):white_C  
                                           +  at(trait,1):M_C + at(trait,1):NN_C
                                           
                                           +  at(trait, 1):prev.rewarded_C
                                           
                                           ,random= ~ ID:corgh(trait, init=init_cor),  rcov= ~ units:corgh(trait, init= init_res), data=data.CJB_discr.learning.biv, maxiter = 100, na.method.X = "include")   # 


init_cor <- c(0, 1,1);   names(init_cor) <- c("F","P" ,"P" )
init_res <- c(0,  1,   0.0000001);   names(init_res) <- c("F", "P", "F" )   


model.CJBLat_Discrlearning_cor0 <-   asreml(cbind(Latency_tr, N.runs.discr_tr)  ~  trait 
                                            +  at(trait,2):white_C  
                                            +  at(trait,1):M_C + at(trait,1):NN_C
                                            
                                            +  at(trait, 1):prev.rewarded_C
                                            
                                            ,random= ~ ID:corgh(trait, init=init_cor),  rcov= ~ units:corgh(trait, init= init_res), data=data.CJB_discr.learning.biv, maxiter = 100, na.method.X = "include")   # 


reml.lrt.asreml (   model.CJBLat_Discrlearning_cor ,model.CJBLat_Discrlearning_cor0  ) # P=0.39



#////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#____________________________________
#  REVERSAL LEARNING
#____________________________________

data.CJB_rev.learning  <-read.table('C:/Dropbox/Linkoping/_Data/data.models_CJB.ambiguous vs RevLearning_2014-2017.csv', header=T, sep=',', dec='.')  #
head(data.CJB_rev.learning )
View(data.CJB_rev.learning )




ID <-  as.factor(data.CJB_rev.learning$ID)

white  <- as.numeric ( data.CJB_rev.learning$trainedcolorRev=="White")
white_C <- ( white -mean (white, na.rm=T) )

N.runs.rev_tr   <- data.CJB_rev.learning$NrunsRevtr



cuetype     <-data.CJB_rev.learning$cuetype
M_C   <-data.CJB_rev.learning$MC
NN_C  <-data.CJB_rev.learning$NNC
run.order_C <-data.CJB_rev.learning$runorderC
first_C <-data.CJB_rev.learning$firstC
prev.rewarded_C   <-data.CJB_rev.learning$prevrewardedC    

Latency_tr <- data.CJB_rev.learning$Latencytr1     
Approached <-data.CJB_rev.learning$Approached


data.CJB_rev.learning.biv <- data.frame (ID, white_C, N.runs.rev_tr,      M_C, NN_C, run.order_C, prev.rewarded_C, Latency_tr, Approached) 


#______________________________

# Models P APPROACH

init_cor <- c(0.1, 1,1);   names(init_cor) <- c("U","P" ,"P" )
init_res <- c(0,  1,   0.0000001);   names(init_res) <- c("F", "P", "F" )   

        
        model.CJBAPPROACH_revlearning_1 <-   asreml(cbind(Approached, N.runs.rev_tr)  ~  trait 
                                                   +  at(trait,2):white_C  
                                                   +  at(trait,1):M_C + at(trait,1):NN_C
                                                   +  at(trait, 1):prev.rewarded_C
                                                   +  at(trait, 1):M_C:prev.rewarded_C +  at(trait, 1):NN_C:prev.rewarded_C
                                                   
                                                   ,random= ~ ID:corgh(trait, init=init_cor),  rcov= ~ units:corgh(trait, init= init_res), data=data.CJB_rev.learning.biv, maxiter = 100, na.method.X = "include")   # 
        
        
        summary(model.CJBAPPROACH_revlearning_1, all=TRUE)$coef.fixed
        summary(model.CJBAPPROACH_revlearning_1, all=TRUE)$varcomp


model.CJBAPPROACH_revlearning_2 <-   asreml(cbind(Approached, N.runs.rev_tr)  ~  trait 
                                           +  at(trait,2):white_C  
                                           +  at(trait,1):M_C + at(trait,1):NN_C
                                           
                                           +  at(trait, 1):prev.rewarded_C
                                           
                                           ,random= ~ ID:corgh(trait, init=init_cor),  rcov= ~ units:corgh(trait, init= init_res), data=data.CJB_rev.learning.biv, maxiter = 100, na.method.X = "include")   # 



summary(model.CJBAPPROACH_revlearning_2, all=TRUE)$coef.fixed
summary(model.CJBAPPROACH_revlearning_2, all=TRUE)$varcomp


nadiv:::pin( model.CJBAPPROACH_revlearning_2 , r~ V1 ) 


init_cor <- c(0.1, 1,1);   names(init_cor) <- c("U","P" ,"P" )
init_res <- c(0,  1,   0.0000001);   names(init_res) <- c("F", "P", "F" )   


model.CJBAPPROACH_revlearning_cov <-   asreml(cbind(Approached, N.runs.rev_tr)  ~  trait 
                                              +  at(trait,2):white_C  
                                              +  at(trait,1):M_C + at(trait,1):NN_C
                                              
                                              +  at(trait, 1):prev.rewarded_C
                                              
                                              ,random= ~ ID:corgh(trait, init=init_cor),  rcov= ~ units:corgh(trait, init= init_res), data=data.CJB_rev.learning.biv, maxiter = 100, na.method.X = "include")   # 






init_cor <- c(0, 1,1);   names(init_cor) <- c("F","P" ,"P" )
init_res <- c(0,  1,   0.0000001);   names(init_res) <- c("F", "P", "F" )   


model.CJBAPPROACH_revlearning_cov0 <-   asreml(cbind(Approached, N.runs.rev_tr)  ~  trait 
                                               +  at(trait,2):white_C  
                                               +  at(trait,1):M_C + at(trait,1):NN_C
                                               
                                               +  at(trait, 1):prev.rewarded_C
                                               
                                               ,random= ~ ID:corgh(trait, init=init_cor),  rcov= ~ units:corgh(trait, init= init_res), data=data.CJB_rev.learning.biv, maxiter = 100, na.method.X = "include")   # 


reml.lrt.asreml (   model.CJBAPPROACH_revlearning_cov ,model.CJBAPPROACH_revlearning_cov0  ) # (P<0.001)


#______________________________________________________________________________________________________________________

# Models  LATENCY APPROACH

summary(model.CJB.3cues.asreml.univ_1);  summary(model.CJB.3cues.asreml.univ_1, all=TRUE)$coef.fixed;  summary(model.CJB.3cues.asreml.univ_1, all=TRUE)$varcomp  #   <-  Compare ***


init_cor <- c(0.1, 1,1);   names(init_cor) <- c("U","P" ,"P" )
init_res <- c(0,  1,   0.0000001);   names(init_res) <- c("F", "P", "F" )   


              model.CJBLat_revlearning_1 <-   asreml(cbind(Latency_tr, N.runs.rev_tr)  ~  trait 
                                                     +  at(trait,2):white_C  
                                                     +  at(trait,1):M_C + at(trait,1):NN_C
                                                     +  at(trait, 1):prev.rewarded_C
                                                     +  at(trait, 1):M_C:prev.rewarded_C +  at(trait, 1):NN_C:prev.rewarded_C
                                                     
                                                     ,random= ~ ID:corgh(trait, init=init_cor),  rcov= ~ units:corgh(trait, init= init_res), data=data.CJB_rev.learning.biv, maxiter = 100, na.method.X = "include")   # 
              
              
              summary(model.CJBLat_revlearning_1, all=TRUE)$coef.fixed
              summary(model.CJBLat_revlearning_1, all=TRUE)$varcomp


model.CJBLat_revlearning_2 <-   asreml(cbind(Latency_tr, N.runs.rev_tr)  ~  trait 
                                       +  at(trait,2):white_C  
                                       +  at(trait,1):M_C + at(trait,1):NN_C
                                       
                                       +  at(trait, 1):prev.rewarded_C
                                       
                                       ,random= ~ ID:corgh(trait, init=init_cor),  rcov= ~ units:corgh(trait, init= init_res), data=data.CJB_rev.learning.biv, maxiter = 100, na.method.X = "include")   # 



summary(model.CJBLat_revlearning_2, all=TRUE)$coef.fixed
summary(model.CJBLat_revlearning_2, all=TRUE)$varcomp


nadiv:::pin(model.CJBLat_revlearning_2 , r~ V1 ) 


init_cor <- c(0.1, 1,1);   names(init_cor) <- c("U","P" ,"P" )
init_res <- c(0,  1,   0.0000001);   names(init_res) <- c("F", "P", "F" )   


model.CJBLat_revlearning_cov <-   asreml(cbind(Latency_tr, N.runs.rev_tr)  ~  trait 
                                         +  at(trait,2):white_C  
                                         +  at(trait,1):M_C + at(trait,1):NN_C
                                         
                                         +  at(trait, 1):prev.rewarded_C
                                         
                                         ,random= ~ ID:corgh(trait, init=init_cor),  rcov= ~ units:corgh(trait, init= init_res), data=data.CJB_rev.learning.biv, maxiter = 100, na.method.X = "include")   # 



init_cor <- c(0, 1,1);   names(init_cor) <- c("F","P" ,"P" )
init_res <- c(0,  1,   0.0000001);   names(init_res) <- c("F", "P", "F" )   

model.CJBLat_revlearning_cov0 <-   asreml(cbind(Latency_tr, N.runs.rev_tr)  ~  trait 
                                          +  at(trait,2):white_C  
                                          +  at(trait,1):M_C + at(trait,1):NN_C
                                          
                                          +  at(trait, 1):prev.rewarded_C
                                          
                                          ,random= ~ ID:corgh(trait, init=init_cor),  rcov= ~ units:corgh(trait, init= init_res), data=data.CJB_rev.learning.biv, maxiter = 100, na.method.X = "include")   # 

reml.lrt.asreml (  model.CJBLat_revlearning_cov ,model.CJBLat_revlearning_cov0  ) # P=0.002


#/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#  CJB:  P Approach-Latency
#_________________________________________________________________________________________________-

init_cor <- c(0.1, 1,1);   names(init_cor) <- c("U","P" ,"P" )
init_res2 <- c(0,  1,   0.16);   names(init_res2) <- c("F", "P", "P" )   



model.CJB.APPROACH_LATENCY_1 <-   asreml(cbind(Approached, Latency_tr)  ~  trait 
                                         +  trait:white_C  
                                         + trait:M_C + at(trait,1):NN_C
                                         +  trait:prev.rewarded_C
                                         +  trait:M_C:prev.rewarded_C +  trait:NN_C:prev.rewarded_C
                                         
                                         ,random= ~ ID:corgh(trait, init=init_cor),  rcov= ~ units:corgh(trait, init= init_res2), data=data.CJB_rev.learning.biv, maxiter = 100, na.method.X = "include")   # 


summary(model.CJB.APPROACH_LATENCY_1, all=TRUE)$coef.fixed
summary(model.CJB.APPROACH_LATENCY_1, all=TRUE)$varcomp


 #  r = -0.58 +- 0.09



init_cor <- c(0.1, 1,1);   names(init_cor) <- c("U","P" ,"P" )
init_res2 <- c(0,  1,   0.16);   names(init_res2) <- c("F", "P", "P" )   


model.CJB.APPROACH_LATENCY_cor <-   asreml(cbind(Approached, Latency_tr)  ~  trait 
                                           +  trait:white_C  
                                           + trait:M_C + at(trait,1):NN_C
                                           +  trait:prev.rewarded_C
                                           +  trait:M_C:prev.rewarded_C +  trait:NN_C:prev.rewarded_C
                                           
                                           ,random= ~ ID:corgh(trait, init=init_cor),  rcov= ~ units:corgh(trait, init= init_res2), data=data.CJB_rev.learning.biv, maxiter = 100, na.method.X = "include")   # 




init_cor <- c(0, 1,1);   names(init_cor) <- c("F","P" ,"P" )
init_res2 <- c(0,  1,   0.16);   names(init_res2) <- c("F", "P", "P" )   


model.CJB.APPROACH_LATENCY_cor0 <-   asreml(cbind(Approached, Latency_tr)  ~  trait 
                                            +  trait:white_C  
                                            + trait:M_C + at(trait,1):NN_C
                                            +  trait:prev.rewarded_C
                                            +  trait:M_C:prev.rewarded_C +  trait:NN_C:prev.rewarded_C
                                            
                                            ,random= ~ ID:corgh(trait, init=init_cor),  rcov= ~ units:corgh(trait, init= init_res2), data=data.CJB_rev.learning.biv, maxiter = 100, na.method.X = "include")   # 

reml.lrt.asreml (   model.CJB.APPROACH_LATENCY_cor , model.CJB.APPROACH_LATENCY_cor0  ) # ( P<0.00001   )


