
library(asreml)
library(asremlPlus)

        
        # Pedigree      
        data.ped  <-read.table('C:/Dropbox/Linkoping/_Data/Pedigree RJFowl 2013-17.csv', header=T, sep=',', dec='.', na.strings='NA')  
             
        RJFped  <-data.frame  (data.ped$ID, data.ped$F.ID, data.ped$M.ID )
        names(RJFped)<-c('ID','F.ID', 'M.ID')
        RJFped$ID<-as.factor(RJFped$ID); RJFped$M.ID<-as.factor(RJFped$M.ID); RJFped$F.ID<-as.factor(RJFped$F.ID)
        
        ainv <-  asreml.Ainverse(RJFped)$ginv
        
        
#||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||####
        
 #  LEARNING ####
        
#|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||####
    
        
          
  #:::::::::::::::::::: #####
  # I. ALL YEARS  ####
  #:::::::::::::::::::: #####
        
  data.learning   <-read.table('C:/Dropbox/Linkoping/_Data/data learning chicks 2013-2017.csv', header=T, sep=',')
  head(data.learning ) ; nrow(data.learning ) 
  data.learning$ID <- as.factor(data.learning$ID)
  data.learning <- data.learning [1:657,]
  
  data.sex   <- unique(read.table('C:/Dropbox/Linkoping/_Data/sex 2012-17.csv', header=T, sep=','))  ;   head(data.sex)
  data.sex$ID <- as.factor(data.sex$ID)
  
  data.learning  <- merge(data.learning, data.sex, by="ID", all.x=TRUE,  all.y=FALSE);  nrow(data.learning ) 
  data.learning <- data.learning[order(data.learning$year, data.learning$ID, data.learning$test),]

  View(data.learning);  head(data.learning)   ;  names(data.learning)
  
  
  
  ID <- data.learning$ID
  sex<- data.learning$sex;   sex <- as.factor(as.character(sex)) ;   F<- as.numeric(sex=="F")
  year <-  data.learning$year  ;     yr2013  <- as.numeric (year==2013);     yr2014  <- as.numeric (year==2014);     yr2015 <- as.numeric (year==2015);     yr2016  <- as.numeric (year==2016);       yr2017  <- as.numeric (year==2017)
  trained.color_ass <- data.learning$trained.color_ass  ; trained.color_rev <- data.learning$trained.color_rev
 
  black.ass  <- as.numeric (trained.color_ass=="Black");     blue.ass <- as.numeric (trained.color_ass=="Blue");   green.ass  <- as.numeric (trained.color_ass=="Green")
  black.rev  <- as.numeric (trained.color_rev=="Black");     blue.rev <- as.numeric (trained.color_rev=="Blue");   green.rev  <- as.numeric (trained.color_rev=="Green")
   
  test<- data.learning$test;  reversal <- as.numeric(test=="rev")
  
  N.runs_ass <- data.learning$N.runs_ass   ;     N.runs_rev <- data.learning$ N.runs_rev
  N.runs.helpless_ass <- data.learning$N.runs_ass_without_help   ;     N.runs.helpless_rev <- data.learning$N.runs_rev_without_help
  N.runs.help_ass <-  N.runs_ass- N.runs.helpless_ass
  
  N.runs <- data.learning$N.runs
  N.runs.helpless  <- data.learning$N.runs_withouthelp
  
  reversal_C  <- reversal-mean(reversal)
  F_C <- F-mean(F, na.rm=T)
  yr2013_C<- yr2013-mean(yr2013, na.rm=T) ;yr2014_C<- yr2014-mean(yr2014, na.rm=T);yr2015_C<- yr2015-mean(yr2015, na.rm=T);yr2016_C<- yr2016-mean(yr2016, na.rm=T);  yr2017_C<- yr2017-mean(yr2017, na.rm=T)
  black.ass_C <- ( black.ass -mean (black.ass, na.rm=T) ) ;   blue.ass_C <- ( blue.ass -mean (blue.ass, na.rm=T) ) ; green.ass_C <- ( green.ass -mean (green.ass, na.rm=T) ) 
  black.rev_C <- ( black.rev -mean (black.rev, na.rm=T) ) ;   blue.rev_C <- ( blue.rev -mean (blue.rev, na.rm=T) ); green.rev_C <- ( green.rev -mean (green.rev, na.rm=T) ) 

  #
  N.runs.ass_tr <- log(N.runs_ass )  ;    hist (  N.runs.ass_tr ) 
    N.runs.helpless.ass_tr  <-  1/( N.runs.helpless_ass) ;   hist(  N.runs.helpless.ass_tr)     #  <............
  N.runs.rev_tr<- log(N.runs_rev )  ;    hist (  N.runs.rev_tr ) 
    N.runs_tr <- log(N.runs )  ;    hist (  N.runs_tr )    
     N.runs.helpless_tr <-log(N.runs.helpless);   hist(N.runs.helpless_tr)
  
  #_____________________________________________ 
        
data.asreml.learning  <-  data.frame (ID,reversal_C, F_C,   yr2014_C,yr2015_C,yr2016_C,yr2017_C,  black.ass_C,blue.ass_C,green.ass_C,   N.runs_tr,  N.runs.helpless_tr  )
        
        library(asreml)      
        
             
# Plots:
              
  hist (N.runs_ass )   ;   hist( N.runs.helpless_ass)
  hist (N.runs_rev )   ;   # hist( N.runs.helpless_rev)
    hist (N.runs)   ;   hist( N.runs.helpless)
  
      plot(jitter(N.runs.help_ass),  jitter(N.runs.helpless_ass), xlim=c(0,70), ylim=c(0,70) , cex=0.5, col=yr2013+1); abline(0,1) # red=2013 
              #plot(N.runs_rev,  N.runs.helpless_rev )
        cor( N.runs.help_ass, N.runs.helpless_ass, method="spearman", use="pairwise.complete.obs") # rs=-0.18
              
     boxplot(N.runs_ass ~  sex, main="Associative learning",ylab="N. runs")        
         boxplot(N.runs.helpless_ass~  sex , main="Associative learning",ylab="N. runs helpless")        
    boxplot(N.runs_rev~  sex, main="Reversal learning" ,ylab="N. runs")         
              
      boxplot(N.runs_ass ~  year, main="Associative learning",ylab="N. runs")        
        boxplot(N.runs.helpless_ass~  year, main="Associative learning",ylab="N. runs helpless" )        
        boxplot(N.runs.help_ass~  year, main="Associative learning",ylab="N. runs helped" )   
      boxplot(N.runs_rev~  year, main="Reversal learning" ,ylab="N. runs")       
              
      boxplot(N.runs_ass ~  trained.color_ass, main="Associative learning",ylab="N. runs")        
          boxplot(N.runs.helpless_ass~  trained.color_ass , main="Associative learning",ylab="N. runs helpless")        
          boxplot(N.runs.help_ass~  trained.color_ass , main="Associative learning",ylab="N. runs helped")        
          
      boxplot(N.runs_rev~ trained.color_rev , main="Reversal learning",ylab="N. runs")  
      
      boxplot(N.runs_ass ~  paste ( trained.color_ass, year), col= c("dark grey", "dark grey",  "dark grey", "dark grey", "blue","green","white" ),ylab="N. runs", main="Associative learning")         
        boxplot(N.runs.helpless_ass~  paste (trained.color_ass, year), col= c("dark grey", "dark grey",  "dark grey", "dark grey", "blue","green","white" ),ylab="N. runs helpless", main="Associative learning" )   
        boxplot(N.runs.help_ass~  paste (trained.color_ass, year), col= c("dark grey", "dark grey",  "dark grey", "dark grey", "blue","green","white" ),ylab="N. runs helped", main="Associative learning" )        
      boxplot(N.runs_rev~ paste (trained.color_rev, year), col= c("dark grey",  "blue", "green", "white","white","white" ,"white"),ylab="N. runs", main="Reversal learning" )  
      

      
#_____________________________
# Associative vs Reversal ####
#_____________________________


 data2 <- unique(na.omit( data.learning[, c(1,2)])) # 
 

data.ass <- na.omit(data.learning[, c(1,2,   4, 9, 10)]) # 
data.rev <- na.omit(data.learning[, c(1,2,   11, 16, 17)])
data.ass_rev <- merge(data2, data.ass, by="ID");  data.ass_rev <- merge(data.ass_rev, data.rev, by="ID")
data.ass_rev <- data.ass_rev [, -c(3)]; names(data.ass_rev)[2] <-"year"
head(data.ass_rev)  ;    nrow(data.ass_rev)


# PLOTS:

   plot( jitter(data.ass_rev$N.runs_ass),   jitter(data.ass_rev$N.runs_rev),  xlim=c(1,75), ylim=c(1,160),  cex=0.6, xlab="No. runs discriminative learning until criterion reached" , ylab="No. runs reversal learning until criterion reached"); abline(0,1, col="grey") #
  
      plot(jitter(data.ass_rev$N.runs_ass_without_help),  jitter( data.ass_rev$N.runs_rev),  xlim=c(1,75), ylim=c(1,160),  cex=0.6,xlab="No. runs discriminative learning until criterion reached" , ylab="No. runs reversal learning until criterion reached"  ); abline(0,1, col="grey")

                 
                 plot( jitter(data.ass_rev$N.runs_ass_without_help),   jitter( data.ass_rev$N.runs_rev),  xlim=c(1,75), ylim=c(1,160),  cex=0.5, xlab="No. runs discriminative learning until criterion reached" , ylab="No. runs reversal learning until criterion reached"); abline(0,1, col="grey")                
plot( jitter(data.ass_rev$N.runs_ass),   jitter(data.ass_rev$N.runs_rev),  xlim=c(1,75), ylim=c(1,160),  cex=0.6, xlab="No. runs discriminative learning until criterion reached" , ylab="No. runs reversal learning until criterion reached",  col= (data.ass_rev$year - 2012) ); abline(0,1, col="grey") # 

 plot( jitter(data.ass_rev$N.runs_ass_without_help),   jitter( data.ass_rev$N.runs_rev),  xlim=c(1,75), ylim=c(1,160),  cex=0.6, xlab="No. runs discriminative learning until criterion reached" , ylab="No. runs reversal learning until criterion reached",  col= 1+as.numeric(data.ass_rev$year==2013)); abline(0,1, col="grey")

cor (data.ass_rev$N.runs_ass,   data.ass_rev$N.runs_rev,  method="spearman") # rs=-0.22
cor.test (data.ass_rev$N.runs_ass,   data.ass_rev$N.runs_rev,  method="spearman", exact = FALSE) # P=0.000036
    cor (data.ass_rev$N.runs_ass,   data.ass_rev$N.runs_rev,  method="kendall") # rs=-0.15
    cor.test (data.ass_rev$N.runs_ass,   data.ass_rev$N.runs_rev,  method="kendall") # P=0.000057
    
      cor (data.ass_rev$N.runs_ass_without_help,   data.ass_rev$N.runs_rev,  method="spearman")  # rs=-0.25

      
      # by YEAR
      data.ass_rev.2013 <- subset(data.ass_rev, data.ass_rev$year=="2013")
      data.ass_rev.2014 <- subset(data.ass_rev, data.ass_rev$year=="2014")
      data.ass_rev.2015 <- subset(data.ass_rev, data.ass_rev$year=="2015")
      data.ass_rev.2016 <- subset(data.ass_rev, data.ass_rev$year=="2016")
      data.ass_rev.2017 <- subset(data.ass_rev, data.ass_rev$year=="2017")
      
      plot( jitter(data.ass_rev.2013$N.runs_ass),   jitter(data.ass_rev.2013$N.runs_rev),  xlim=c(1,75), ylim=c(1,160),  cex=0.6, xlab="No. runs discriminative learning until criterion reached" , ylab="No. runs reversal learning until criterion reached", main="Year 2013"); abline(0,1, col="grey") #
      plot( jitter(data.ass_rev.2014$N.runs_ass),   jitter(data.ass_rev.2014$N.runs_rev),  xlim=c(1,75), ylim=c(1,160),  cex=0.6, xlab="No. runs discriminative learning until criterion reached" , ylab="No. runs reversal learning until criterion reached", main="Year 2014"); abline(0,1, col="grey") #
      plot( jitter(data.ass_rev.2015$N.runs_ass),   jitter(data.ass_rev.2015$N.runs_rev),  xlim=c(1,75), ylim=c(1,160),  cex=0.6, xlab="No. runs discriminative learning until criterion reached" , ylab="No. runs reversal learning until criterion reached", main="Year 2015"); abline(0,1, col="grey") #
      plot( jitter(data.ass_rev.2016$N.runs_ass),   jitter(data.ass_rev.2016$N.runs_rev),  xlim=c(1,75), ylim=c(1,160),  cex=0.6, xlab="No. runs discriminative learning until criterion reached" , ylab="No. runs reversal learning until criterion reached", main="Year 2016"); abline(0,1, col="grey") #
      plot( jitter(data.ass_rev.2017$N.runs_ass),   jitter(data.ass_rev.2017$N.runs_rev),  xlim=c(1,75), ylim=c(1,160),  cex=0.6, xlab="No. runs discriminative learning until criterion reached" , ylab="No. runs reversal learning until criterion reached", main="Year 2017"); abline(0,1, col="grey") #
      
      cor (data.ass_rev.2013$N.runs_ass,   data.ass_rev.2013$N.runs_rev,  method="spearman") # rs= -0.11
      cor (data.ass_rev.2014$N.runs_ass,   data.ass_rev.2014$N.runs_rev,  method="spearman") # rs= -0.12
      cor (data.ass_rev.2015$N.runs_ass,   data.ass_rev.2015$N.runs_rev,  method="spearman") # rs= -0.13
      cor (data.ass_rev.2016$N.runs_ass,   data.ass_rev.2016$N.runs_rev,  method="spearman") # rs= -0.01 <-
      cor (data.ass_rev.2017$N.runs_ass,   data.ass_rev.2017$N.runs_rev,  method="spearman") # rs= -0.11
    
      
      
       
# MODELS
      
      
#___________________________________________
#____1.) OVERALL  Learning (ASS + REV) ####      
#___________________________________________



  #______________________
  # 1.) N. runs tot ***
 #______________________
  
 #............
  # 0 + Vr
 #............+
      
      model.learning.asreml.CSA_0   <- asreml(    N.runs_tr  ~ 1 + F_C 
                                                ,                                                    
                                                   data=data.asreml.learning, maxiter = 100, na.method.X = "include") 
      
  model.learning.asreml.CSA_0a   <- asreml(    N.runs_tr  ~ 1 + F_C 
                                               +    reversal_C*black.ass_C +  reversal_C*blue.ass_C  + reversal_C*green.ass_C  ,                                                    
                                               data=data.asreml.learning, maxiter = 100, na.method.X = "include") 
  
  model.learning.asreml.CSA_0b   <- asreml(    N.runs_tr  ~ 1+ F_C 
                                               + reversal_C +    black.ass_C +  blue.ass_C  + green.ass_C  ,                                                    
                                               data=data.asreml.learning, maxiter = 100, na.method.X = "include")  
  
  model.learning.asreml.CSA_0c   <- asreml(    N.runs_tr  ~ 1+ F_C 
                                               +    reversal_C* yr2014_C +    reversal_C* yr2015_C+    reversal_C* yr2016_C+    reversal_C* yr2017_C,                                                    
                                               data=data.asreml.learning, maxiter = 100, na.method.X = "include")  
  
  model.learning.asreml.CSA_0d   <- asreml(    N.runs_tr  ~ 1+ F_C 
                                               +    reversal_C+  yr2014_C + yr2015_C+yr2016_C+yr2017_C,                                                    
                                               data=data.asreml.learning, maxiter = 100, na.method.X = "include")  
  
  summary(model.learning.asreml.CSA_0  , all=TRUE)$coef.fixed  
  summary(model.learning.asreml.CSA_0a  , all=TRUE)$coef.fixed  
  summary(model.learning.asreml.CSA_0b  , all=TRUE)$coef.fixed
  summary(model.learning.asreml.CSA_0c  , all=TRUE)$coef.fixed
  summary(model.learning.asreml.CSA_0d  , all=TRUE)$coef.fixed
  
  
  #...............
  # VID + Vr 
  
  #.............
  
  model.learning.asreml.CSA_1   <- asreml(   N.runs_tr  ~ 1 + F_C 
                                             ,                                                      
                                              random =~ ID ,  data=data.asreml.learning, maxiter = 100, na.method.X = "include") 
  
  
  model.learning.asreml.CSA_1a   <- asreml(   N.runs_tr  ~ 1 + F_C 
                                              +    reversal_C*black.ass_C +  reversal_C*blue.ass_C  + reversal_C*green.ass_C  ,                                                      
                                              random =~ ID ,  data=data.asreml.learning, maxiter = 100, na.method.X = "include") 
  
  model.learning.asreml.CSA_1b   <- asreml(   N.runs_tr  ~ 1+ F_C 
                                              + reversal_C +    black.ass_C +  blue.ass_C  + green.ass_C  ,   
                                               random =~ ID ,  data=data.asreml.learning, maxiter = 100, na.method.X = "include") 
  
  model.learning.asreml.CSA_1c   <- asreml(     N.runs_tr  ~ 1+ F_C 
                                                +    reversal_C* yr2014_C +    reversal_C* yr2015_C+    reversal_C* yr2016_C+    reversal_C* yr2017_C, 
                                               random =~ ID ,  data=data.asreml.learning, maxiter = 100, na.method.X = "include") 
  
  model.learning.asreml.CSA_1d  <- asreml(     N.runs_tr  ~ 1+ F_C 
                                                +    reversal_C+ yr2014_C +    yr2015_C+  yr2016_C+ yr2017_C, 
                                                random =~ ID ,  data=data.asreml.learning, maxiter = 100, na.method.X = "include") 
  
  summary(model.learning.asreml.CSA_1  , all=TRUE)$coef.fixed
  summary(model.learning.asreml.CSA_1a  , all=TRUE)$coef.fixed  
  summary(model.learning.asreml.CSA_1b  , all=TRUE)$coef.fixed
  summary(model.learning.asreml.CSA_1c  , all=TRUE)$coef.fixed
  summary(model.learning.asreml.CSA_1d  , all=TRUE)$coef.fixed

  summary(model.learning.asreml.CSA_1  , all=TRUE)$varcomp 
  summary(model.learning.asreml.CSA_1a  , all=TRUE)$varcomp
  summary(model.learning.asreml.CSA_1b  , all=TRUE)$varcomp 
  summary(model.learning.asreml.CSA_1c  , all=TRUE)$varcomp 
  summary(model.learning.asreml.CSA_1d  , all=TRUE)$varcomp 
      
  
             
   
   
              
              
              
  
#___________________________________

# 2.) DISCRIMINATIVE LEARNING ####
#____________________________________
  
data.ass <- subset (data.learning, data.learning$test=="ass")
head(data.ass);  names(data.ass)


ID <-data.ass$ID
sex<-data.ass$sex;   sex <- as.factor(as.character(sex)) ;F<- as.numeric(sex=="F")
year <- data.ass$year;    yr2013  <- as.numeric (year==2013); yr2014  <- as.numeric (year==2014); yr2015  <- as.numeric (year==2015);  yr2016  <- as.numeric (year==2016);  yr2017  <- as.numeric (year==2017)
trained.color_ass <-data.ass$trained.color_ass  
black.ass  <- as.numeric (trained.color_ass=="Black"); blue.ass <- as.numeric (trained.color_ass=="Blue");   green.ass  <- as.numeric (trained.color_ass=="Green")
  #  BLUE GREEN: 2013
  # BLACK: 2014(1/2), 2015,2016, 2017
  # WHITE: 2014 (1/2)
N.runs.ass <-data.ass$N.runs_ass  
  N.runs.helpless.ass <-data.ass$N.runs_ass_without_help   
  N.runs.help.ass  <- N.runs.ass - N.runs.helpless.ass

N.runs.ass_tr <-log (N.runs.ass );   hist(N.runs.ass_tr)
  N.runs.help.ass_tr <-log (N.runs.help.ass +1)
  N.runs.helpless.ass_tr  <-  1/( N.runs.helpless.ass) ;   hist(  N.runs.helpless.ass_tr)     # 

F_C <- F-mean(F, na.rm=T)
yr2013_C<- yr2013-mean(yr2013, na.rm=T);  yr2014_C<- yr2014-mean(yr2014, na.rm=T);  yr2015_C<- yr2015-mean(yr2015, na.rm=T);   yr2016_C<- yr2016-mean(yr2016, na.rm=T);   yr2017_C<- yr2017-mean(yr2017, na.rm=T)
black.ass_C <- ( black.ass -mean (black.ass, na.rm=T) );   blue.ass_C <- ( blue.ass -mean (blue.ass, na.rm=T) ) ; green.ass_C <- ( green.ass -mean (green.ass, na.rm=T) ) 

N.runs.help_C <- ( N.runs.help.ass -mean (N.runs.help.ass, na.rm=T) ) / (2*sd(N.runs.help.ass, na.rm=T))

  
# PLOTS:
plot(N.runs.help.ass, N.runs.helpless.ass, xlim=c(1,70), ylim=c(1,70), cex=.5, col=year-2012 ) # 
  cor(N.runs.help.ass, N.runs.helpless.ass, method="spearman")    # rs= -0.18
      plot(N.runs.help.ass, N.runs.ass, xlim=c(1,70), ylim=c(1,70), cex=.5, col=(year-2012)  ) # 
        cor(N.runs.help.ass, N.runs.ass, method="spearman")    # rs= 0.57
      



data.asreml.ass <- data.frame (ID, F_C, yr2013_C,  yr2014_C,yr2015_C, yr2016_C, yr2017_C, black.ass_C , blue.ass_C , green.ass_C ,N.runs.ass, N.runs.ass_tr  ,N.runs.helpless.ass_tr )

#***********
# Models

library(asreml)

#__________________________
# 1.) N. runs tot
#__________________________

  #............
  # 0 + Vr
  #............

  model.Asslearning.asreml.CSA_0a   <- asreml(    N.runs.ass_tr  ~ 1 + F_C 
                                                  +    black.ass_C +  blue.ass_C  + green.ass_C 
                                                  , data=data.asreml.ass, maxiter = 100, na.method.X = "include")  
  
  model.Asslearning.asreml.CSA_0b   <- asreml(    N.runs.ass_tr  ~ 1 + F_C 
                                                  +    yr2014_C +  yr2015_C  + yr2016_C + yr2017_C 
                                                  , data=data.asreml.ass, maxiter = 100, na.method.X = "include")  
  
      model.Asslearning.asreml.CSA_0c   <- asreml(    N.runs.ass_tr  ~ 1 + F_C
                                                      +    yr2013_C  
                                                      , data=data.asreml.ass, maxiter = 100, na.method.X = "include")  

  summary(   model.Asslearning.asreml.CSA_0a   , all=TRUE)$coef.fixed 
  summary(   model.Asslearning.asreml.CSA_0b   , all=TRUE)$coef.fixed 
  summary(   model.Asslearning.asreml.CSA_0c   , all=TRUE)$coef.fixed 
  
  
  #............
  # Vg +  Vr  
  #............
      
      model.Asslearning.asreml.CSA_1   <- asreml(   N.runs.ass_tr  ~  1 + F_C
                                                    ,                                                       
                                                     random =~  ped (ID, var=T)  ,  ginverse=list(ID=ainv) ,  data=data.asreml.ass, maxiter = 100, na.method.X = "include") 
      
  model.Asslearning.asreml.CSA_1a   <- asreml(   N.runs.ass_tr  ~  1 + F_C
                                                 +    black.ass_C +  blue.ass_C  + green.ass_C  ,                                                       
                                                 random =~  ped (ID, var=T)  ,  ginverse=list(ID=ainv) ,  data=data.asreml.ass, maxiter = 100, na.method.X = "include") 
  
  model.Asslearning.asreml.CSA_1b   <- asreml(    N.runs.ass_tr  ~  1 + F_C 
                                                  +    yr2014_C +  yr2015_C  + yr2016_C  + yr2017_C ,   
                                                  random =~  ped (ID, var=T)  ,  ginverse=list(ID=ainv) ,  data=data.asreml.ass, maxiter = 100, na.method.X = "include") 
  
        model.Asslearning.asreml.CSA_1c  <- asreml(    N.runs.ass_tr  ~  1 + F_C 
                                                       +    yr2013_C   ,   
                                                        random =~  ped (ID, var=T)  ,  ginverse=list(ID=ainv) ,  data=data.asreml.ass, maxiter = 100, na.method.X = "include") 

  
  summary(   model.Asslearning.asreml.CSA_1a   , all=TRUE)$coef.fixed
  summary(   model.Asslearning.asreml.CSA_1b   , all=TRUE)$coef.fixed
  summary(   model.Asslearning.asreml.CSA_1c   , all=TRUE)$coef.fixed 
  
  summary(   model.Asslearning.asreml.CSA_1a   , all=TRUE)$varcomp 
  summary(   model.Asslearning.asreml.CSA_1b   , all=TRUE)$varcomp 
  summary(   model.Asslearning.asreml.CSA_1c   , all=TRUE)$varcomp
            
  
  
        
        
        
      barplot ((as.matrix (c( 1.519730e-01,  2.664805e-08)) ) , col= c(" grey", "blue"), xlab= "Discriminative learning",  ylab="variance")
  
  library(nadiv)
      
    nadiv:::pin(model.Asslearning.asreml.CSA_1 , h2~ V1/(V1+V2) )  #  h2=  0.22 +- 0.10 (SE) *
  nadiv:::pin(model.Asslearning.asreml.CSA_1a , h2~ V1/(V1+V2) ) #  h2=  0.001 +- 0.06 (SE)
  nadiv:::pin(model.Asslearning.asreml.CSA_1b , h2~ V1/(V1+V2) ) #  h2=  0 +- 0 (SE)
  nadiv:::pin(model.Asslearning.asreml.CSA_1c , h2~ V1/(V1+V2) ) #  h2=  0.03 +- 0.08 (SE)
        
  
  
        
  model.Asslearning.asreml.CSA_0   <- asreml(   N.runs.ass_tr  ~  1 + F_C
                                                +    black.ass_C +  blue.ass_C  + green.ass_C  ,                                                       
                                                data=data.asreml.ass, maxiter = 100, na.method.X = "include") 
  
  
  reml.lrt.asreml (   model.Asslearning.asreml.CSA_1a ,  model.Asslearning.asreml.CSA_0  ) # P=0.99  -> /2= 0.49
  
  
            
#___________________________________
# 3.) REVERSAL LEARNING ####
#__________________________      
          
data.rev <- subset (data.learning, data.learning$test=="rev")
head(data.rev);  names(data.rev)


ID <-data.rev$ID
 sex<-data.rev$sex;   sex <- as.factor(as.character(sex)) ;F<- as.numeric(sex=="F")
year <- data.rev$year;   yr2013  <- as.numeric (year==2013);  yr2014  <- as.numeric (year==2014); yr2015  <- as.numeric (year==2015);  yr2016  <- as.numeric (year==2016);  yr2017 <- as.numeric (year==2017)
trained.color_rev <-data.rev$trained.color_rev  
black.rev  <- as.numeric (trained.color_rev=="Black");     blue.rev <- as.numeric (trained.color_rev=="Blue");   green.rev  <- as.numeric (trained.color_rev=="Green")
N.runs_rev <-data.rev$N.runs_rev  
    N.runs.helpless_rev <-data.rev$N.runs_rev_without_help   

 F_C <- F-mean(F, na.rm=T)
yr2013_C<- yr2013-mean(yr2013, na.rm=T);yr2014_C<- yr2014-mean(yr2014, na.rm=T);  yr2015_C<- yr2015-mean(yr2015, na.rm=T);   yr2016_C<- yr2016-mean(yr2016, na.rm=T);   yr2017_C<- yr2017-mean(yr2017, na.rm=T)
black.rev_C <- ( black.rev -mean (black.rev, na.rm=T) ) ;   blue.rev_C <- ( blue.rev -mean (blue.rev, na.rm=T) ); green.rev_C <- ( green.rev -mean (green.rev, na.rm=T) )


N.runs.rev_tr <- log(N.runs_rev )  ;    hist (  N.runs.rev_tr ) 


data.asreml.rev <- data.frame (ID, F_C,  yr2013_C, yr2014_C,yr2015_C, yr2016_C, yr2017_C, black.rev_C , blue.rev_C , green.rev_C ,N.runs.rev_tr   )




#_____________________
# MODELS


library(asreml)


#________________
#  N. runs tot
#________________

   #...........
    # 0 + Vr
  #...........

        model.Revlearning.asreml.CSA_0   <- asreml(    N.runs.rev_tr  ~ 1 + F_C 
                                                 ,                                                    
                                                data=data.asreml.rev, maxiter = 100, na.method.X = "include") 

    model.Revlearning.asreml.CSA_0a   <- asreml(    N.runs.rev_tr  ~ 1 + F_C 
                                                    +    black.rev_C +  blue.rev_C  + green.rev_C  ,                                                    
                                                    data=data.asreml.rev, maxiter = 100, na.method.X = "include") 
    
    model.Revlearning.asreml.CSA_0b   <- asreml(    N.runs.rev_tr  ~ 1 + F_C
                                                    +    yr2014_C +  yr2015_C  + yr2016_C + yr2017_C ,                                                    
                                                    data=data.asreml.rev, maxiter = 100, na.method.X = "include")  
    
    model.Revlearning.asreml.CSA_0c   <- asreml(    N.runs.rev_tr  ~ 1 + F_C 
                                                    +    yr2013_C  ,                                                    
                                                    data=data.asreml.rev, maxiter = 100, na.method.X = "include")  
    
    summary(   model.Revlearning.asreml.CSA_0a   , all=TRUE)$coef.fixed
    summary(   model.Revlearning.asreml.CSA_0b   , all=TRUE)$coef.fixed 
    summary(   model.Revlearning.asreml.CSA_0c   , all=TRUE)$coef.fixed 
    

    #............           
    # Vg +  Vr 
    #...........
    
        model.Revlearning.asreml.CSA_1   <- asreml(   N.runs.rev_tr  ~  1 + F_C    
                                                          ,                                                       
                                                       random =~  ped (ID, var=T)  ,  ginverse=list(ID=ainv) ,  data=data.asreml.rev, maxiter = 100, na.method.X = "include") 
        
    model.Revlearning.asreml.CSA_1a   <- asreml(   N.runs.rev_tr  ~  1 + F_C +   
                                                     black.rev_C +  blue.rev_C  + green.rev_C  ,                                                       
                                                   random =~  ped (ID, var=T)  ,  ginverse=list(ID=ainv) ,  data=data.asreml.rev, maxiter = 100, na.method.X = "include") 
    
    model.Revlearning.asreml.CSA_1b   <- asreml(    N.runs.rev_tr  ~  1 + F_C + 
                                                      yr2014_C +  yr2015_C  + yr2016_C + yr2017_C ,   
                                                    random =~  ped (ID, var=T)  ,  ginverse=list(ID=ainv) ,  data=data.asreml.rev, maxiter = 100, na.method.X = "include") 
    
    model.Revlearning.asreml.CSA_1c  <- asreml(    N.runs.rev_tr  ~  1 + F_C +  
                                                     yr2013_C   ,   
                                                   random =~  ped (ID, var=T)  ,  ginverse=list(ID=ainv) ,  data=data.asreml.rev, maxiter = 100, na.method.X = "include") 
    
    
                               
   summary( model.Revlearning.asreml.CSA_1a, all=T )$coef.fixed  
   summary( model.Revlearning.asreml.CSA_1b, all=T )$coef.fixed  
   summary( model.Revlearning.asreml.CSA_1c, all=T )$coef.fixed 
   
   summary( model.Revlearning.asreml.CSA_1a )
   summary( model.Revlearning.asreml.CSA_1b)
   summary( model.Revlearning.asreml.CSA_1c) 
   
  
   
   
   
# h2  +- SE:
  
   nadiv:::pin( model.Revlearning.asreml.CSA_1, h2~ V1/(V1+V2) )    #  h2=  0.33 +- 0.11 (SE)
   nadiv:::pin( model.Revlearning.asreml.CSA_1a, h2~ V1/(V1+V2) )    #  h2=  0.26 +- 0.11 (SE)
   nadiv:::pin( model.Revlearning.asreml.CSA_1b, h2~ V1/(V1+V2) )    #  h2=  0.26 +- 0.11 (SE)
   nadiv:::pin( model.Revlearning.asreml.CSA_1c, h2~ V1/(V1+V2) )    #  h2=  0.26 +- 0.11 (SE)
   
   

   model.Revlearning.asreml.CSA_1a   <- asreml(   N.runs.rev_tr  ~  1 + F_C +   
                                                    black.rev_C +  blue.rev_C  + green.rev_C  ,                                                       
                                                  random =~  ped (ID, var=T)  ,  ginverse=list(ID=ainv) ,  data=data.asreml.rev, maxiter = 100, na.method.X = "include") 
   
   model.Revlearning.asreml.CSA_0  <- asreml(   N.runs.rev_tr  ~  1 + F_C +   
                                                  black.rev_C +  blue.rev_C  + green.rev_C  ,                                                       
                                                data=data.asreml.rev, maxiter = 100, na.method.X = "include") 
   
   
   reml.lrt.asreml (   model.Revlearning.asreml.CSA_1a ,  model.Revlearning.asreml.CSA_0  ) # P<0.01  



#/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
   
  
  #:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: ####
  # II. Excluding 2013 =>  YEARS 2014-2017  ####
               # => matching CJB data
  #:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: ####

   data.learning   <-read.table('C:/Dropbox/Linkoping/_Data/data learning chicks 2013-2017.csv', header=T, sep=',')
   head(data.learning )    ; nrow(data.learning ) 
   data.learning$ID <- as.factor(data.learning$ID)
   data.learning <- data.learning [1:657,]
   
   data.sex   <- unique(read.table('C:/Dropbox/Linkoping/_Data/sex 2012-17.csv', header=T, sep=','))  ;   head(data.sex)
   data.sex$ID <- as.factor(data.sex$ID)
   
   data.learning  <- merge(data.learning, data.sex, by="ID", all.x=TRUE,  all.y=FALSE);  nrow(data.learning ) 
   data.learning <- data.learning[order(data.learning$year, data.learning$ID, data.learning$test),]

   
data.learning.2014_17   <-subset (data.learning,data.learning$year>2013 )
      head(data.learning.2014_17  ); nrow(data.learning.2014_17  ) 
      View(data.learning.2014_17 )

ID <- data.learning.2014_17$ID
sex<- data.learning.2014_17$sex;   sex <- as.factor(as.character(sex)) ;F<- as.numeric(sex=="F")
year <-  data.learning.2014_17$year ;   yr2014  <- as.numeric (year==2014);     yr2015 <- as.numeric (year==2015);     yr2016  <- as.numeric (year==2016);       yr2017  <- as.numeric (year==2017)

trained.color_ass <- as.factor(as.character(data.learning.2014_17$trained.color_ass )) ; trained.color_rev <- as.factor(as.character(data.learning.2014_17$trained.color_rev))

black.ass  <- as.numeric (trained.color_ass=="Black")
black.rev  <- as.numeric (trained.color_rev=="Black")


test<- data.learning.2014_17$test;  reversal <- as.numeric(test=="rev")

N.runs_ass <- data.learning.2014_17$N.runs_ass   
N.runs_rev <- data.learning.2014_17$ N.runs_rev
    N.runs.helpless_ass <- data.learning.2014_17$N.runs_ass_without_help   
    N.runs.helpless_rev <- data.learning.2014_17$N.runs_rev_without_help
    
  N.runs <- data.learning.2014_17$N.runs
    N.runs.helpless <- data.learning.2014_17$N.runs_withouthelp

F_C <- F-mean(F, na.rm=T)
 yr2015_C<- yr2015-mean(yr2015, na.rm=T);   yr2016_C<- yr2016-mean(yr2016, na.rm=T);   yr2017_C<- yr2017-mean(yr2017, na.rm=T)

black.ass_C <- ( black.ass -mean (black.ass, na.rm=T) ) 
black.rev_C <- ( black.rev -mean (black.rev, na.rm=T) )   
reversal_C <- reversal - mean(reversal, na.rm=T)


hist (N.runs_ass )   ;   hist( N.runs.helpless_ass)
hist (N.runs_rev )   ;   hist( N.runs.helpless_rev)

    plot(N.runs_ass,  N.runs.helpless_ass, xlim=c(0,70), ylim=c(0,70) )
    plot(N.runs_rev,  N.runs.helpless_rev )


boxplot(N.runs_ass ~  sex)        
  boxplot(N.runs.helpless_ass~  sex )        
boxplot(N.runs_rev~  sex )         

boxplot(N.runs_ass ~  year)        
  boxplot(N.runs.helpless_ass~  year )        
boxplot(N.runs_rev~  year )       

boxplot(N.runs_ass ~  trained.color_ass)       #  
  boxplot(N.runs.helpless_ass~  trained.color_ass )        
boxplot(N.runs_rev~ trained.color_rev )    #  

boxplot(N.runs_ass ~  paste (  year, trained.color_ass), col= c("dark grey","white",  "dark grey", "dark grey" )) 
tapply(N.runs_ass , paste (  year, trained.color_ass), median)
  boxplot(N.runs.helpless_ass~  paste (  year, trained.color_ass), col= c("dark grey","white",  "dark grey", "dark grey" ))        
boxplot(N.runs_rev~ paste (year, trained.color_rev), col= c("dark grey", "white","white","white" ,"white") )  
tapply(N.runs_rev , paste (  year, trained.color_rev), median)

          # ass vs rev
               names(data.learning.2014_17)
          data2 <- unique(( data.learning.2014_17[, c(1,2,  62)])) #   <------<<
          data.ass <- na.omit(data.learning.2014_17[, c(1,2,   4, 9, 10)]) 
          data.rev <- na.omit(data.learning.2014_17[, c(1,2,   11, 16, 17)])

          
          data.ass_rev <- merge(data2, data.ass, by="ID", all=TRUE);  data.ass_rev <- merge(data.ass_rev, data.rev, by="ID", all=TRUE)
          data.ass_rev <- data.ass_rev [, -c(2,3)]
          
          head(data.ass_rev);  nrow(data.ass_rev)
          data.ass_rev <- data.ass_rev [-61,]
          data.ass_rev <- data.ass_rev [, -6]
          names (data.ass_rev)[2]  <- "year"
          data.ass_rev<- data.ass_rev[ !is.na(data.ass_rev$N.runs_rev), ]
          
          plot( data.ass_rev$N.runs_ass,   data.ass_rev$N.runs_rev,  xlim=c(1,70), ylim=c(1,160),  cex=0.6,  col= data.ass_rev$year -2013); abline(0,1) # black=2014, red=2015, green=2016, blue=2017
            plot( data.ass_rev$N.runs_ass,   data.ass_rev$N.runs_rev,  xlim=c(1,70), ylim=c(1,160),  cex=0.6,  col= as.numeric (data.ass_rev$year==2014)); abline(0,1) # year 2014
            plot( data.ass_rev$N.runs_ass,   data.ass_rev$N.runs_rev,  xlim=c(1,70), ylim=c(1,160),  cex=0.6,  col= as.numeric (data.ass_rev$year==2015)); abline(0,1) # year 2015
            plot( data.ass_rev$N.runs_ass,   data.ass_rev$N.runs_rev,  xlim=c(1,70), ylim=c(1,160),  cex=0.6,  col= as.numeric (data.ass_rev$year==2016)); abline(0,1) # year 2016
            plot( data.ass_rev$N.runs_ass,   data.ass_rev$N.runs_rev,  xlim=c(1,70), ylim=c(1,160),  cex=0.6,  col= as.numeric (data.ass_rev$year==2017)); abline(0,1) # year 2017
            
              plot(data.ass_rev$N.runs_ass_without_help,   data.ass_rev$N.runs_rev,  xlim=c(1,70), ylim=c(1,160),  cex=0.6,  col= data.ass_rev$year -2013); abline(0,1)
          
  cor (data.ass_rev$N.runs_ass,   data.ass_rev$N.runs_rev,  method="spearman")  # r= -0.11
  cor.test (data.ass_rev$N.runs_ass,   data.ass_rev$N.runs_rev,  method="spearman", exact = FALSE) # P= 0.09
      cor (data.ass_rev$N.runs_ass_without_help,   data.ass_rev$N.runs_rev,  method="spearman")

N.runs.ass_tr <- log(N.runs_ass )  ;    hist (  N.runs.ass_tr ) 
    N.runs.helpless.ass_tr  <-  1/( N.runs.helpless_ass) ;   hist(  N.runs.helpless.ass_tr)     #  <..................

N.runs.rev_tr<- log(N.runs_rev )  ;    hist (  N.runs.rev_tr ) 
 

  N.runs_tr <- log(N.runs )  ;   hist(N.runs_tr)
      N.runs.helpless_tr  <-  1/( N.runs.helpless)  ;   hist(N.runs.helpless_tr)

       
      
#_____________________________________________ 
      
  data.asreml.learning2014_17  <-  data.frame (ID,reversal_C, F_C, yr2015_C,yr2016_C,yr2017_C ,  black.ass_C  ,   N.runs_tr,  N.runs.helpless_tr  )
      
      library(asreml)      
      
      
      
      
      # MODELS
      
      
      #___________________________________________
      #____1.) OVERALL  Learning (ASS + REV) ####      
      #___________________________________________
      
 
      #______________________
      # 1.) N. runs tot ***
      #______________________
      
      #............
      # 0 + Vr
      #............+
      
      model.learning.asreml.CSA_0   <- asreml(    N.runs_tr  ~ 1 + F_C 
                                                  ,                                                    
                                                  data=data.asreml.learning2014_17, maxiter = 100, na.method.X = "include") 
      
      model.learning.asreml.CSA_0a   <- asreml(    N.runs_tr  ~ 1 + F_C 
                                                   +    reversal_C*black.ass_C  ,                                                    
                                                   data=data.asreml.learning2014_17, maxiter = 100, na.method.X = "include") 
      
      model.learning.asreml.CSA_0b   <- asreml(    N.runs_tr  ~ 1+ F_C 
                                                   + reversal_C +    black.ass_C   ,                                                    
                                                   data=data.asreml.learning2014_17, maxiter = 100, na.method.X = "include")  
      
      model.learning.asreml.CSA_0c   <- asreml(    N.runs_tr  ~ 1+ F_C 
                                                   +     reversal_C* yr2015_C+    reversal_C* yr2016_C+    reversal_C* yr2017_C,                                                    
                                                   data=data.asreml.learning2014_17, maxiter = 100, na.method.X = "include")  
      
      model.learning.asreml.CSA_0d   <- asreml(    N.runs_tr  ~ 1+ F_C 
                                                   +    reversal_C  + yr2015_C+yr2016_C+yr2017_C,                                                    
                                                   data=data.asreml.learning2014_17, maxiter = 100, na.method.X = "include")  
      
      summary(model.learning.asreml.CSA_0  , all=TRUE)$coef.fixed  
      summary(model.learning.asreml.CSA_0a  , all=TRUE)$coef.fixed  
      summary(model.learning.asreml.CSA_0b  , all=TRUE)$coef.fixed
      summary(model.learning.asreml.CSA_0c  , all=TRUE)$coef.fixed
      summary(model.learning.asreml.CSA_0d  , all=TRUE)$coef.fixed
      
      
      #...............
      # VID + Vr 
      #.............
      
      model.learning.asreml.CSA_1   <- asreml(   N.runs_tr  ~ 1 + F_C 
                                                 ,                                                      
                                                 random =~ ID ,  data=data.asreml.learning2014_17, maxiter = 100, na.method.X = "include") 
      
      
      model.learning.asreml.CSA_1a   <- asreml(   N.runs_tr  ~ 1 + F_C 
                                                  +    reversal_C*black.ass_C ,                                                      
                                                  random =~ ID ,  data=data.asreml.learning2014_17, maxiter = 100, na.method.X = "include") 
      
      model.learning.asreml.CSA_1b   <- asreml(   N.runs_tr  ~ 1+ F_C 
                                                  + reversal_C +    black.ass_C  ,   
                                                  random =~ ID ,  data=data.asreml.learning2014_17, maxiter = 100, na.method.X = "include") 
      
      model.learning.asreml.CSA_1c   <- asreml(     N.runs_tr  ~ 1+ F_C 
                                                    +    reversal_C* yr2015_C+    reversal_C* yr2016_C+    reversal_C* yr2017_C, 
                                                    random =~ ID ,  data=data.asreml.learning2014_17, maxiter = 100, na.method.X = "include") 
      
      model.learning.asreml.CSA_1d  <- asreml(     N.runs_tr  ~ 1+ F_C 
                                                   +    reversal_C+     yr2015_C+  yr2016_C+ yr2017_C, 
                                                   random =~ ID ,  data=data.asreml.learning2014_17, maxiter = 100, na.method.X = "include") 
      
      summary(model.learning.asreml.CSA_1  , all=TRUE)$coef.fixed
      summary(model.learning.asreml.CSA_1a  , all=TRUE)$coef.fixed  
      summary(model.learning.asreml.CSA_1b  , all=TRUE)$coef.fixed
      summary(model.learning.asreml.CSA_1c  , all=TRUE)$coef.fixed
      summary(model.learning.asreml.CSA_1d  , all=TRUE)$coef.fixed
      
      summary(model.learning.asreml.CSA_1  , all=TRUE)$varcomp 
      summary(model.learning.asreml.CSA_1a  , all=TRUE)$varcomp
      summary(model.learning.asreml.CSA_1b  , all=TRUE)$varcomp 
      summary(model.learning.asreml.CSA_1c  , all=TRUE)$varcomp 
      summary(model.learning.asreml.CSA_1d  , all=TRUE)$varcomp 
      
      
     
      
      
      #___________________________________
      
      # 2.) DISCRIMINATIVE LEARNING ####
      #____________________________________
      
      data.ass.2014_2017 <- subset (data.learning, data.learning$test=="ass")
      data.ass.2014_2017 <- subset (data.ass.2014_2017, data.ass.2014_2017$year>2013)
      head(data.ass.2014_2017);  names(data.ass.2014_2017)
      
      
      ID <-data.ass.2014_2017$ID
      sex<-data.ass.2014_2017$sex;   sex <- as.factor(as.character(sex)) ;F<- as.numeric(sex=="F")
      year <- data.ass.2014_2017$year;    yr2014  <- as.numeric (year==2014); yr2015  <- as.numeric (year==2015);  yr2016  <- as.numeric (year==2016);  yr2017  <- as.numeric (year==2017)
      trained.color_ass <-data.ass.2014_2017$trained.color_ass  
      black.ass  <- as.numeric (trained.color_ass=="Black")
      # WHITE: 2014 (1/2)
      N.runs.ass <-data.ass.2014_2017$N.runs_ass  
      N.runs.helpless.ass <-data.ass.2014_2017$N.runs_ass_without_help   
      N.runs.help.ass  <- N.runs.ass - N.runs.helpless.ass
      
      N.runs.ass_tr <-log (N.runs.ass );   hist(N.runs.ass_tr)
      N.runs.help.ass_tr <-log (N.runs.help.ass +1)
      N.runs.helpless.ass_tr  <-  1/( N.runs.helpless.ass) ;   hist(  N.runs.helpless.ass_tr)     #  <===============  NB helpless tr negative related with original
      
      F_C <- F-mean(F, na.rm=T)
      yr2015_C<- yr2015-mean(yr2015, na.rm=T);   yr2016_C<- yr2016-mean(yr2016, na.rm=T);   yr2017_C<- yr2017-mean(yr2017, na.rm=T)
      black.ass_C <- ( black.ass -mean (black.ass, na.rm=T) )
      
      N.runs.help_C <- ( N.runs.help.ass -mean (N.runs.help.ass, na.rm=T) ) / (2*sd(N.runs.help.ass, na.rm=T))
      
      
      # PLOTS:
      plot(N.runs.help.ass, N.runs.helpless.ass, xlim=c(1,70), ylim=c(1,70), cex=.5, col=year-2012 ) # 
      cor(N.runs.help.ass, N.runs.helpless.ass, method="spearman")    # rs= 0
      plot(N.runs.help.ass, N.runs.ass, xlim=c(1,70), ylim=c(1,70), cex=.5, col=(year-2012)  ) # 
      cor(N.runs.help.ass, N.runs.ass, method="spearman")    # rs= 0.80
      
      
      
      
      data.asreml.ass.2014_2017 <- data.frame (ID, F_C,  yr2015_C, yr2016_C, yr2017_C, black.ass_C ,N.runs.ass_tr  ,N.runs.helpless.ass_tr )
      
      #***********
      # Models
      
      library(asreml)
      
      #__________________________
      # 1.) N. runs tot
      #__________________________
      
      #............
      # 0 + Vr
      #............
      
      model.Asslearning.asreml.CSA_0a   <- asreml(    N.runs.ass_tr  ~ 1 + F_C 
                                                      +    black.ass_C 
                                                      , data=data.asreml.ass.2014_2017, maxiter = 100, na.method.X = "include")  
      
      model.Asslearning.asreml.CSA_0b   <- asreml(    N.runs.ass_tr  ~ 1 + F_C 
                                                      +  yr2015_C  + yr2016_C + yr2017_C 
                                                      , data=data.asreml.ass.2014_2017, maxiter = 100, na.method.X = "include")  
      
      summary(   model.Asslearning.asreml.CSA_0a   , all=TRUE)$coef.fixed 
      summary(   model.Asslearning.asreml.CSA_0b   , all=TRUE)$coef.fixed 
      
      
      
      #............
      # Vg +  Vr  
      #............
      
      model.Asslearning.asreml.CSA_1   <- asreml(   N.runs.ass_tr  ~  1 + F_C
                                                    ,                                                       
                                                    random =~  ped (ID, var=T)  ,  ginverse=list(ID=ainv) ,  data=data.asreml.ass.2014_2017, maxiter = 100, na.method.X = "include") 
      
      model.Asslearning.asreml.CSA_1a   <- asreml(   N.runs.ass_tr  ~  1 + F_C
                                                     +    black.ass_C ,                                                       
                                                     random =~  ped (ID, var=T)  ,  ginverse=list(ID=ainv) ,  data=data.asreml.ass.2014_2017, maxiter = 100, na.method.X = "include") 
      
      model.Asslearning.asreml.CSA_1b   <- asreml(    N.runs.ass_tr  ~  1 + F_C 
                                                      +    yr2015_C  + yr2016_C  + yr2017_C ,   
                                                      random =~  ped (ID, var=T)  ,  ginverse=list(ID=ainv) ,  data=data.asreml.ass.2014_2017, maxiter = 100, na.method.X = "include") 
      
      
      summary(   model.Asslearning.asreml.CSA_1a   , all=TRUE)$coef.fixed
      summary(   model.Asslearning.asreml.CSA_1b   , all=TRUE)$coef.fixed
      
      summary(   model.Asslearning.asreml.CSA_1   , all=TRUE)$varcomp 
      summary(   model.Asslearning.asreml.CSA_1a   , all=TRUE)$varcomp 
      summary(   model.Asslearning.asreml.CSA_1b   , all=TRUE)$varcomp 
      
      
       
      library(nadiv)
      
      nadiv:::pin(model.Asslearning.asreml.CSA_1 , h2~ V1/(V1+V2) )  #  h2=  0.07 +- 0.09 (SE) 
      nadiv:::pin(model.Asslearning.asreml.CSA_1a , h2~ V1/(V1+V2) ) #  h2=  0.05 +- 0.08 (SE)
      nadiv:::pin(model.Asslearning.asreml.CSA_1b , h2~ V1/(V1+V2) ) #  h2=  0.002 +- 0.08 (SE)
      nadiv:::pin(model.Asslearning.asreml.CSA_1c , h2~ V1/(V1+V2) ) #  h2=  0.03 +- 0.08 (SE)
      
      
      
      
#___________________________________
# 3.) REVERSAL LEARNING ####
#__________________________      
      
      data.rev.2014_2017 <- subset (data.learning, data.learning$test=="rev")
      data.rev.2014_2017 <- subset (data.rev.2014_2017, data.rev.2014_2017$year>2013)
      head(data.rev.2014_2017);  names(data.rev.2014_2017)
      
      
      ID <-data.rev.2014_2017$ID
      sex<-data.rev.2014_2017$sex;   sex <- as.factor(as.character(sex)) ;F<- as.numeric(sex=="F")
      year <- data.rev.2014_2017$year;   yr2014  <- as.numeric (year==2014); yr2015  <- as.numeric (year==2015);  yr2016  <- as.numeric (year==2016);  yr2017 <- as.numeric (year==2017)
      trained.color_rev <-data.rev.2014_2017$trained.color_rev  
      black.rev  <- as.numeric (trained.color_rev=="Black")
      N.runs_rev <-data.rev.2014_2017$N.runs_rev  
      N.runs.helpless_rev <-data.rev.2014_2017$N.runs_rev_without_help   
      
      F_C <- F-mean(F, na.rm=T)
      yr2015_C<- yr2015-mean(yr2015, na.rm=T);   yr2016_C<- yr2016-mean(yr2016, na.rm=T);   yr2017_C<- yr2017-mean(yr2017, na.rm=T)
      black.rev_C <- ( black.rev -mean (black.rev, na.rm=T) ) 
      
      
      N.runs.rev_tr <- log(N.runs_rev )  ;    hist (  N.runs.rev_tr ) 
      #N.runs.helpless.rev_tr  <-  1/( N.runs.helpless_rev) ;   hist(  N.runs.helpless.rev_tr)     #  <===============  NB helpless tr negative related with original
      
      
      data.asreml.rev <- data.frame (ID, F_C, yr2015_C, yr2016_C, yr2017_C, black.rev_C ,N.runs.rev_tr   )
      
      
      
      
      #_____________________
      # MODELS
      
      
      library(asreml)
      
      
      #________________
      #  N. runs tot
      #________________
      
      #...........
      # 0 + Vr
      #...........
      
      model.Revlearning.asreml.CSA_0   <- asreml(    N.runs.rev_tr  ~ 1 + F_C 
                                                     ,                                                    
                                                     data=data.asreml.rev, maxiter = 100, na.method.X = "include") 
      
      model.Revlearning.asreml.CSA_0a   <- asreml(    N.runs.rev_tr  ~ 1 + F_C 
                                                      +    black.rev_C ,                                                    
                                                      data=data.asreml.rev, maxiter = 100, na.method.X = "include") 
      
      model.Revlearning.asreml.CSA_0b   <- asreml(    N.runs.rev_tr  ~ 1 + F_C
                                                      +    yr2015_C  + yr2016_C + yr2017_C ,                                                    
                                                      data=data.asreml.rev, maxiter = 100, na.method.X = "include")  
      
      summary(   model.Revlearning.asreml.CSA_0a   , all=TRUE)$coef.fixed
      summary(   model.Revlearning.asreml.CSA_0b   , all=TRUE)$coef.fixed 
      
      
      
      #............           
      # Vg +  Vr 
      #...........
      
      model.Revlearning.asreml.CSA_1   <- asreml(   N.runs.rev_tr  ~  1 + F_C    
                                                    ,                                                       
                                                    random =~  ped (ID, var=T)  ,  ginverse=list(ID=ainv) ,  data=data.asreml.rev, maxiter = 100, na.method.X = "include") 
      
      model.Revlearning.asreml.CSA_1a   <- asreml(   N.runs.rev_tr  ~  1 + F_C +   
                                                       black.rev_C  ,                                                       
                                                     random =~  ped (ID, var=T)  ,  ginverse=list(ID=ainv) ,  data=data.asreml.rev, maxiter = 100, na.method.X = "include") 
      
      model.Revlearning.asreml.CSA_1b   <- asreml(    N.runs.rev_tr  ~  1 + F_C + 
                                                        yr2015_C  + yr2016_C + yr2017_C ,   
                                                      random =~  ped (ID, var=T)  ,  ginverse=list(ID=ainv) ,  data=data.asreml.rev, maxiter = 100, na.method.X = "include") 
      
      
      
      
      summary( model.Revlearning.asreml.CSA_1a, all=T )$coef.fixed  
      summary( model.Revlearning.asreml.CSA_1b, all=T )$coef.fixed  
      
      summary( model.Revlearning.asreml.CSA_1 )
      summary( model.Revlearning.asreml.CSA_1a )
      summary( model.Revlearning.asreml.CSA_1b)
      
      
 
      
      # h2  +- SE:

      nadiv:::pin( model.Revlearning.asreml.CSA_1, h2~ V1/(V1+V2) )    #  h2=  0.25 +- 0.12 (SE)
      nadiv:::pin( model.Revlearning.asreml.CSA_1a, h2~ V1/(V1+V2) )    #  h2=  0.26 +- 0.12 (SE)
      nadiv:::pin( model.Revlearning.asreml.CSA_1b, h2~ V1/(V1+V2) )    #  h2=  0.26 +- 0.13 (SE)
 
      
      





#____________________________________________________________________________________________

